#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
impl super::CSR {
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = r"Value of the field"]
pub struct AWD1R {
    bits: bool,
}
impl AWD1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Value of the field"]
pub struct EOC1R {
    bits: bool,
}
impl EOC1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Value of the field"]
pub struct JEOC1R {
    bits: bool,
}
impl JEOC1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Value of the field"]
pub struct JSTRT1R {
    bits: bool,
}
impl JSTRT1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Value of the field"]
pub struct STRT1R {
    bits: bool,
}
impl STRT1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Value of the field"]
pub struct OVR1R {
    bits: bool,
}
impl OVR1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Value of the field"]
pub struct ADONS1R {
    bits: bool,
}
impl ADONS1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Analog watchdog flag of the ADC"]
    #[inline(always)]
    pub fn awd1(&self) -> AWD1R {
        let bits = ((self.bits >> 0) & 0x01) != 0;
        AWD1R { bits }
    }
    #[doc = "Bit 1 - End of conversion of the ADC"]
    #[inline(always)]
    pub fn eoc1(&self) -> EOC1R {
        let bits = ((self.bits >> 1) & 0x01) != 0;
        EOC1R { bits }
    }
    #[doc = "Bit 2 - Injected channel end of conversion of the ADC"]
    #[inline(always)]
    pub fn jeoc1(&self) -> JEOC1R {
        let bits = ((self.bits >> 2) & 0x01) != 0;
        JEOC1R { bits }
    }
    #[doc = "Bit 3 - Injected channel Start flag of the ADC"]
    #[inline(always)]
    pub fn jstrt1(&self) -> JSTRT1R {
        let bits = ((self.bits >> 3) & 0x01) != 0;
        JSTRT1R { bits }
    }
    #[doc = "Bit 4 - Regular channel Start flag of the ADC"]
    #[inline(always)]
    pub fn strt1(&self) -> STRT1R {
        let bits = ((self.bits >> 4) & 0x01) != 0;
        STRT1R { bits }
    }
    #[doc = "Bit 5 - Overrun flag of the ADC"]
    #[inline(always)]
    pub fn ovr1(&self) -> OVR1R {
        let bits = ((self.bits >> 5) & 0x01) != 0;
        OVR1R { bits }
    }
    #[doc = "Bit 6 - ADON Status of ADC1"]
    #[inline(always)]
    pub fn adons1(&self) -> ADONS1R {
        let bits = ((self.bits >> 6) & 0x01) != 0;
        ADONS1R { bits }
    }
}
