#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::CSR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct TSUSPR {
    bits: bool,
}
impl TSUSPR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _TSUSPW<'a> {
    w: &'a mut W,
}
impl<'a> _TSUSPW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 31);
        self.w.bits |= ((value as u32) & 0x01) << 31;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CAIFR {
    bits: bool,
}
impl CAIFR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Value of the field"]
pub struct CAIER {
    bits: bool,
}
impl CAIER {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CAIEW<'a> {
    w: &'a mut W,
}
impl<'a> _CAIEW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 29);
        self.w.bits |= ((value as u32) & 0x01) << 29;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct RCH13R {
    bits: bool,
}
impl RCH13R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _RCH13W<'a> {
    w: &'a mut W,
}
impl<'a> _RCH13W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 28);
        self.w.bits |= ((value as u32) & 0x01) << 28;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct FCH8R {
    bits: bool,
}
impl FCH8R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _FCH8W<'a> {
    w: &'a mut W,
}
impl<'a> _FCH8W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 27);
        self.w.bits |= ((value as u32) & 0x01) << 27;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct FCH3R {
    bits: bool,
}
impl FCH3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _FCH3W<'a> {
    w: &'a mut W,
}
impl<'a> _FCH3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 26);
        self.w.bits |= ((value as u32) & 0x01) << 26;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OUTSELR {
    bits: u8,
}
impl OUTSELR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _OUTSELW<'a> {
    w: &'a mut W,
}
impl<'a> _OUTSELW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x07 << 21);
        self.w.bits |= ((value as u32) & 0x07) << 21;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct INSELR {
    bits: u8,
}
impl INSELR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _INSELW<'a> {
    w: &'a mut W,
}
impl<'a> _INSELW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x07 << 18);
        self.w.bits |= ((value as u32) & 0x07) << 18;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct WNDWER {
    bits: bool,
}
impl WNDWER {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _WNDWEW<'a> {
    w: &'a mut W,
}
impl<'a> _WNDWEW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 17);
        self.w.bits |= ((value as u32) & 0x01) << 17;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct VREFOUTENR {
    bits: bool,
}
impl VREFOUTENR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _VREFOUTENW<'a> {
    w: &'a mut W,
}
impl<'a> _VREFOUTENW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 16);
        self.w.bits |= ((value as u32) & 0x01) << 16;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CMP2OUTR {
    bits: bool,
}
impl CMP2OUTR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Value of the field"]
pub struct SPEEDR {
    bits: bool,
}
impl SPEEDR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _SPEEDW<'a> {
    w: &'a mut W,
}
impl<'a> _SPEEDW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 12);
        self.w.bits |= ((value as u32) & 0x01) << 12;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CMP1OUTR {
    bits: bool,
}
impl CMP1OUTR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Value of the field"]
pub struct SW1R {
    bits: bool,
}
impl SW1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _SW1W<'a> {
    w: &'a mut W,
}
impl<'a> _SW1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 5);
        self.w.bits |= ((value as u32) & 0x01) << 5;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CMP1ENR {
    bits: bool,
}
impl CMP1ENR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CMP1ENW<'a> {
    w: &'a mut W,
}
impl<'a> _CMP1ENW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 4);
        self.w.bits |= ((value as u32) & 0x01) << 4;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct PD400KR {
    bits: bool,
}
impl PD400KR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _PD400KW<'a> {
    w: &'a mut W,
}
impl<'a> _PD400KW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 3);
        self.w.bits |= ((value as u32) & 0x01) << 3;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct PD10KR {
    bits: bool,
}
impl PD10KR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _PD10KW<'a> {
    w: &'a mut W,
}
impl<'a> _PD10KW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 2);
        self.w.bits |= ((value as u32) & 0x01) << 2;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct PU400KR {
    bits: bool,
}
impl PU400KR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _PU400KW<'a> {
    w: &'a mut W,
}
impl<'a> _PU400KW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 1);
        self.w.bits |= ((value as u32) & 0x01) << 1;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct PU10KR {
    bits: bool,
}
impl PU10KR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _PU10KW<'a> {
    w: &'a mut W,
}
impl<'a> _PU10KW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 0);
        self.w.bits |= ((value as u32) & 0x01) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 31 - Suspend Timer Mode"]
    #[inline(always)]
    pub fn tsusp(&self) -> TSUSPR {
        let bits = ((self.bits >> 31) & 0x01) != 0;
        TSUSPR { bits }
    }
    #[doc = "Bit 30 - Channel acquisition interrupt flag"]
    #[inline(always)]
    pub fn caif(&self) -> CAIFR {
        let bits = ((self.bits >> 30) & 0x01) != 0;
        CAIFR { bits }
    }
    #[doc = "Bit 29 - Channel Acquisition Interrupt Enable / Clear"]
    #[inline(always)]
    pub fn caie(&self) -> CAIER {
        let bits = ((self.bits >> 29) & 0x01) != 0;
        CAIER { bits }
    }
    #[doc = "Bit 28 - Select GPIO port PC3 as re-routed ADC input channel CH13."]
    #[inline(always)]
    pub fn rch13(&self) -> RCH13R {
        let bits = ((self.bits >> 28) & 0x01) != 0;
        RCH13R { bits }
    }
    #[doc = "Bit 27 - Select GPIO port PB0 as fast ADC input channel CH8."]
    #[inline(always)]
    pub fn fch8(&self) -> FCH8R {
        let bits = ((self.bits >> 27) & 0x01) != 0;
        FCH8R { bits }
    }
    #[doc = "Bit 26 - Select GPIO port PA3 as fast ADC input channel CH3."]
    #[inline(always)]
    pub fn fch3(&self) -> FCH3R {
        let bits = ((self.bits >> 26) & 0x01) != 0;
        FCH3R { bits }
    }
    #[doc = "Bits 21:23 - Comparator 2 output selection"]
    #[inline(always)]
    pub fn outsel(&self) -> OUTSELR {
        let bits = ((self.bits >> 21) & 0x07) as u8;
        OUTSELR { bits }
    }
    #[doc = "Bits 18:20 - Inverted input selection"]
    #[inline(always)]
    pub fn insel(&self) -> INSELR {
        let bits = ((self.bits >> 18) & 0x07) as u8;
        INSELR { bits }
    }
    #[doc = "Bit 17 - Window mode enable"]
    #[inline(always)]
    pub fn wndwe(&self) -> WNDWER {
        let bits = ((self.bits >> 17) & 0x01) != 0;
        WNDWER { bits }
    }
    #[doc = "Bit 16 - VREFINT output enable"]
    #[inline(always)]
    pub fn vrefouten(&self) -> VREFOUTENR {
        let bits = ((self.bits >> 16) & 0x01) != 0;
        VREFOUTENR { bits }
    }
    #[doc = "Bit 13 - Comparator 2 output"]
    #[inline(always)]
    pub fn cmp2out(&self) -> CMP2OUTR {
        let bits = ((self.bits >> 13) & 0x01) != 0;
        CMP2OUTR { bits }
    }
    #[doc = "Bit 12 - Comparator 2 speed mode"]
    #[inline(always)]
    pub fn speed(&self) -> SPEEDR {
        let bits = ((self.bits >> 12) & 0x01) != 0;
        SPEEDR { bits }
    }
    #[doc = "Bit 7 - Comparator 1 output"]
    #[inline(always)]
    pub fn cmp1out(&self) -> CMP1OUTR {
        let bits = ((self.bits >> 7) & 0x01) != 0;
        CMP1OUTR { bits }
    }
    #[doc = "Bit 5 - SW1 analog switch enable"]
    #[inline(always)]
    pub fn sw1(&self) -> SW1R {
        let bits = ((self.bits >> 5) & 0x01) != 0;
        SW1R { bits }
    }
    #[doc = "Bit 4 - Comparator 1 enable"]
    #[inline(always)]
    pub fn cmp1en(&self) -> CMP1ENR {
        let bits = ((self.bits >> 4) & 0x01) != 0;
        CMP1ENR { bits }
    }
    #[doc = "Bit 3 - 400 kO pull-down resistor"]
    #[inline(always)]
    pub fn pd400k(&self) -> PD400KR {
        let bits = ((self.bits >> 3) & 0x01) != 0;
        PD400KR { bits }
    }
    #[doc = "Bit 2 - 10 kO pull-down resistor"]
    #[inline(always)]
    pub fn pd10k(&self) -> PD10KR {
        let bits = ((self.bits >> 2) & 0x01) != 0;
        PD10KR { bits }
    }
    #[doc = "Bit 1 - 400 kO pull-up resistor"]
    #[inline(always)]
    pub fn pu400k(&self) -> PU400KR {
        let bits = ((self.bits >> 1) & 0x01) != 0;
        PU400KR { bits }
    }
    #[doc = "Bit 0 - 10 kO pull-up resistor"]
    #[inline(always)]
    pub fn pu10k(&self) -> PU10KR {
        let bits = ((self.bits >> 0) & 0x01) != 0;
        PU10KR { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 31 - Suspend Timer Mode"]
    #[inline(always)]
    pub fn tsusp(&mut self) -> _TSUSPW {
        _TSUSPW { w: self }
    }
    #[doc = "Bit 29 - Channel Acquisition Interrupt Enable / Clear"]
    #[inline(always)]
    pub fn caie(&mut self) -> _CAIEW {
        _CAIEW { w: self }
    }
    #[doc = "Bit 28 - Select GPIO port PC3 as re-routed ADC input channel CH13."]
    #[inline(always)]
    pub fn rch13(&mut self) -> _RCH13W {
        _RCH13W { w: self }
    }
    #[doc = "Bit 27 - Select GPIO port PB0 as fast ADC input channel CH8."]
    #[inline(always)]
    pub fn fch8(&mut self) -> _FCH8W {
        _FCH8W { w: self }
    }
    #[doc = "Bit 26 - Select GPIO port PA3 as fast ADC input channel CH3."]
    #[inline(always)]
    pub fn fch3(&mut self) -> _FCH3W {
        _FCH3W { w: self }
    }
    #[doc = "Bits 21:23 - Comparator 2 output selection"]
    #[inline(always)]
    pub fn outsel(&mut self) -> _OUTSELW {
        _OUTSELW { w: self }
    }
    #[doc = "Bits 18:20 - Inverted input selection"]
    #[inline(always)]
    pub fn insel(&mut self) -> _INSELW {
        _INSELW { w: self }
    }
    #[doc = "Bit 17 - Window mode enable"]
    #[inline(always)]
    pub fn wndwe(&mut self) -> _WNDWEW {
        _WNDWEW { w: self }
    }
    #[doc = "Bit 16 - VREFINT output enable"]
    #[inline(always)]
    pub fn vrefouten(&mut self) -> _VREFOUTENW {
        _VREFOUTENW { w: self }
    }
    #[doc = "Bit 12 - Comparator 2 speed mode"]
    #[inline(always)]
    pub fn speed(&mut self) -> _SPEEDW {
        _SPEEDW { w: self }
    }
    #[doc = "Bit 5 - SW1 analog switch enable"]
    #[inline(always)]
    pub fn sw1(&mut self) -> _SW1W {
        _SW1W { w: self }
    }
    #[doc = "Bit 4 - Comparator 1 enable"]
    #[inline(always)]
    pub fn cmp1en(&mut self) -> _CMP1ENW {
        _CMP1ENW { w: self }
    }
    #[doc = "Bit 3 - 400 kO pull-down resistor"]
    #[inline(always)]
    pub fn pd400k(&mut self) -> _PD400KW {
        _PD400KW { w: self }
    }
    #[doc = "Bit 2 - 10 kO pull-down resistor"]
    #[inline(always)]
    pub fn pd10k(&mut self) -> _PD10KW {
        _PD10KW { w: self }
    }
    #[doc = "Bit 1 - 400 kO pull-up resistor"]
    #[inline(always)]
    pub fn pu400k(&mut self) -> _PU400KW {
        _PU400KW { w: self }
    }
    #[doc = "Bit 0 - 10 kO pull-up resistor"]
    #[inline(always)]
    pub fn pu10k(&mut self) -> _PU10KW {
        _PU10KW { w: self }
    }
}
