#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::IMR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = "Possible values of the field `MR0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MR0R {
    #[doc = "Interrupt request line is masked"]
    MASKED,
    #[doc = "Interrupt request line is unmasked"]
    UNMASKED,
}
impl MR0R {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            MR0R::MASKED => false,
            MR0R::UNMASKED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> MR0R {
        match value {
            false => MR0R::MASKED,
            true => MR0R::UNMASKED,
        }
    }
    #[doc = "Checks if the value of the field is `MASKED`"]
    #[inline(always)]
    pub fn is_masked(&self) -> bool {
        *self == MR0R::MASKED
    }
    #[doc = "Checks if the value of the field is `UNMASKED`"]
    #[inline(always)]
    pub fn is_unmasked(&self) -> bool {
        *self == MR0R::UNMASKED
    }
}
#[doc = "Values that can be written to the field `MR0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MR0W {
    #[doc = "Interrupt request line is masked"]
    MASKED,
    #[doc = "Interrupt request line is unmasked"]
    UNMASKED,
}
impl MR0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            MR0W::MASKED => false,
            MR0W::UNMASKED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _MR0W<'a> {
    w: &'a mut W,
}
impl<'a> _MR0W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 0);
        self.w.bits |= ((value as u32) & 0x01) << 0;
        self.w
    }
}
#[doc = "Possible values of the field `MR1`"]
pub type MR1R = MR0R;
#[doc = "Values that can be written to the field `MR1`"]
pub type MR1W = MR0W;
#[doc = r"Proxy"]
pub struct _MR1W<'a> {
    w: &'a mut W,
}
impl<'a> _MR1W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 1);
        self.w.bits |= ((value as u32) & 0x01) << 1;
        self.w
    }
}
#[doc = "Possible values of the field `MR2`"]
pub type MR2R = MR0R;
#[doc = "Values that can be written to the field `MR2`"]
pub type MR2W = MR0W;
#[doc = r"Proxy"]
pub struct _MR2W<'a> {
    w: &'a mut W,
}
impl<'a> _MR2W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 2);
        self.w.bits |= ((value as u32) & 0x01) << 2;
        self.w
    }
}
#[doc = "Possible values of the field `MR3`"]
pub type MR3R = MR0R;
#[doc = "Values that can be written to the field `MR3`"]
pub type MR3W = MR0W;
#[doc = r"Proxy"]
pub struct _MR3W<'a> {
    w: &'a mut W,
}
impl<'a> _MR3W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 3);
        self.w.bits |= ((value as u32) & 0x01) << 3;
        self.w
    }
}
#[doc = "Possible values of the field `MR4`"]
pub type MR4R = MR0R;
#[doc = "Values that can be written to the field `MR4`"]
pub type MR4W = MR0W;
#[doc = r"Proxy"]
pub struct _MR4W<'a> {
    w: &'a mut W,
}
impl<'a> _MR4W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR4W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 4);
        self.w.bits |= ((value as u32) & 0x01) << 4;
        self.w
    }
}
#[doc = "Possible values of the field `MR5`"]
pub type MR5R = MR0R;
#[doc = "Values that can be written to the field `MR5`"]
pub type MR5W = MR0W;
#[doc = r"Proxy"]
pub struct _MR5W<'a> {
    w: &'a mut W,
}
impl<'a> _MR5W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR5W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 5);
        self.w.bits |= ((value as u32) & 0x01) << 5;
        self.w
    }
}
#[doc = "Possible values of the field `MR6`"]
pub type MR6R = MR0R;
#[doc = "Values that can be written to the field `MR6`"]
pub type MR6W = MR0W;
#[doc = r"Proxy"]
pub struct _MR6W<'a> {
    w: &'a mut W,
}
impl<'a> _MR6W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR6W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 6);
        self.w.bits |= ((value as u32) & 0x01) << 6;
        self.w
    }
}
#[doc = "Possible values of the field `MR7`"]
pub type MR7R = MR0R;
#[doc = "Values that can be written to the field `MR7`"]
pub type MR7W = MR0W;
#[doc = r"Proxy"]
pub struct _MR7W<'a> {
    w: &'a mut W,
}
impl<'a> _MR7W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR7W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 7);
        self.w.bits |= ((value as u32) & 0x01) << 7;
        self.w
    }
}
#[doc = "Possible values of the field `MR8`"]
pub type MR8R = MR0R;
#[doc = "Values that can be written to the field `MR8`"]
pub type MR8W = MR0W;
#[doc = r"Proxy"]
pub struct _MR8W<'a> {
    w: &'a mut W,
}
impl<'a> _MR8W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR8W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 8);
        self.w.bits |= ((value as u32) & 0x01) << 8;
        self.w
    }
}
#[doc = "Possible values of the field `MR9`"]
pub type MR9R = MR0R;
#[doc = "Values that can be written to the field `MR9`"]
pub type MR9W = MR0W;
#[doc = r"Proxy"]
pub struct _MR9W<'a> {
    w: &'a mut W,
}
impl<'a> _MR9W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR9W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 9);
        self.w.bits |= ((value as u32) & 0x01) << 9;
        self.w
    }
}
#[doc = "Possible values of the field `MR10`"]
pub type MR10R = MR0R;
#[doc = "Values that can be written to the field `MR10`"]
pub type MR10W = MR0W;
#[doc = r"Proxy"]
pub struct _MR10W<'a> {
    w: &'a mut W,
}
impl<'a> _MR10W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR10W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 10);
        self.w.bits |= ((value as u32) & 0x01) << 10;
        self.w
    }
}
#[doc = "Possible values of the field `MR11`"]
pub type MR11R = MR0R;
#[doc = "Values that can be written to the field `MR11`"]
pub type MR11W = MR0W;
#[doc = r"Proxy"]
pub struct _MR11W<'a> {
    w: &'a mut W,
}
impl<'a> _MR11W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR11W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 11);
        self.w.bits |= ((value as u32) & 0x01) << 11;
        self.w
    }
}
#[doc = "Possible values of the field `MR12`"]
pub type MR12R = MR0R;
#[doc = "Values that can be written to the field `MR12`"]
pub type MR12W = MR0W;
#[doc = r"Proxy"]
pub struct _MR12W<'a> {
    w: &'a mut W,
}
impl<'a> _MR12W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR12W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 12);
        self.w.bits |= ((value as u32) & 0x01) << 12;
        self.w
    }
}
#[doc = "Possible values of the field `MR13`"]
pub type MR13R = MR0R;
#[doc = "Values that can be written to the field `MR13`"]
pub type MR13W = MR0W;
#[doc = r"Proxy"]
pub struct _MR13W<'a> {
    w: &'a mut W,
}
impl<'a> _MR13W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR13W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 13);
        self.w.bits |= ((value as u32) & 0x01) << 13;
        self.w
    }
}
#[doc = "Possible values of the field `MR14`"]
pub type MR14R = MR0R;
#[doc = "Values that can be written to the field `MR14`"]
pub type MR14W = MR0W;
#[doc = r"Proxy"]
pub struct _MR14W<'a> {
    w: &'a mut W,
}
impl<'a> _MR14W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR14W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 14);
        self.w.bits |= ((value as u32) & 0x01) << 14;
        self.w
    }
}
#[doc = "Possible values of the field `MR15`"]
pub type MR15R = MR0R;
#[doc = "Values that can be written to the field `MR15`"]
pub type MR15W = MR0W;
#[doc = r"Proxy"]
pub struct _MR15W<'a> {
    w: &'a mut W,
}
impl<'a> _MR15W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR15W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 15);
        self.w.bits |= ((value as u32) & 0x01) << 15;
        self.w
    }
}
#[doc = "Possible values of the field `MR16`"]
pub type MR16R = MR0R;
#[doc = "Values that can be written to the field `MR16`"]
pub type MR16W = MR0W;
#[doc = r"Proxy"]
pub struct _MR16W<'a> {
    w: &'a mut W,
}
impl<'a> _MR16W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR16W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 16);
        self.w.bits |= ((value as u32) & 0x01) << 16;
        self.w
    }
}
#[doc = "Possible values of the field `MR17`"]
pub type MR17R = MR0R;
#[doc = "Values that can be written to the field `MR17`"]
pub type MR17W = MR0W;
#[doc = r"Proxy"]
pub struct _MR17W<'a> {
    w: &'a mut W,
}
impl<'a> _MR17W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR17W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 17);
        self.w.bits |= ((value as u32) & 0x01) << 17;
        self.w
    }
}
#[doc = "Possible values of the field `MR18`"]
pub type MR18R = MR0R;
#[doc = "Values that can be written to the field `MR18`"]
pub type MR18W = MR0W;
#[doc = r"Proxy"]
pub struct _MR18W<'a> {
    w: &'a mut W,
}
impl<'a> _MR18W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR18W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 18);
        self.w.bits |= ((value as u32) & 0x01) << 18;
        self.w
    }
}
#[doc = "Possible values of the field `MR19`"]
pub type MR19R = MR0R;
#[doc = "Values that can be written to the field `MR19`"]
pub type MR19W = MR0W;
#[doc = r"Proxy"]
pub struct _MR19W<'a> {
    w: &'a mut W,
}
impl<'a> _MR19W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR19W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 19);
        self.w.bits |= ((value as u32) & 0x01) << 19;
        self.w
    }
}
#[doc = "Possible values of the field `MR20`"]
pub type MR20R = MR0R;
#[doc = "Values that can be written to the field `MR20`"]
pub type MR20W = MR0W;
#[doc = r"Proxy"]
pub struct _MR20W<'a> {
    w: &'a mut W,
}
impl<'a> _MR20W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR20W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 20);
        self.w.bits |= ((value as u32) & 0x01) << 20;
        self.w
    }
}
#[doc = "Possible values of the field `MR21`"]
pub type MR21R = MR0R;
#[doc = "Values that can be written to the field `MR21`"]
pub type MR21W = MR0W;
#[doc = r"Proxy"]
pub struct _MR21W<'a> {
    w: &'a mut W,
}
impl<'a> _MR21W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR21W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 21);
        self.w.bits |= ((value as u32) & 0x01) << 21;
        self.w
    }
}
#[doc = "Possible values of the field `MR22`"]
pub type MR22R = MR0R;
#[doc = "Values that can be written to the field `MR22`"]
pub type MR22W = MR0W;
#[doc = r"Proxy"]
pub struct _MR22W<'a> {
    w: &'a mut W,
}
impl<'a> _MR22W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MR22W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt request line is masked"]
    #[inline(always)]
    pub fn masked(self) -> &'a mut W {
        self.variant(MR0W::MASKED)
    }
    #[doc = "Interrupt request line is unmasked"]
    #[inline(always)]
    pub fn unmasked(self) -> &'a mut W {
        self.variant(MR0W::UNMASKED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 22);
        self.w.bits |= ((value as u32) & 0x01) << 22;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr0(&self) -> MR0R {
        MR0R::_from(((self.bits >> 0) & 0x01) != 0)
    }
    #[doc = "Bit 1 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr1(&self) -> MR1R {
        MR1R::_from(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr2(&self) -> MR2R {
        MR2R::_from(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr3(&self) -> MR3R {
        MR3R::_from(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr4(&self) -> MR4R {
        MR4R::_from(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr5(&self) -> MR5R {
        MR5R::_from(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr6(&self) -> MR6R {
        MR6R::_from(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr7(&self) -> MR7R {
        MR7R::_from(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr8(&self) -> MR8R {
        MR8R::_from(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr9(&self) -> MR9R {
        MR9R::_from(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr10(&self) -> MR10R {
        MR10R::_from(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr11(&self) -> MR11R {
        MR11R::_from(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr12(&self) -> MR12R {
        MR12R::_from(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr13(&self) -> MR13R {
        MR13R::_from(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr14(&self) -> MR14R {
        MR14R::_from(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr15(&self) -> MR15R {
        MR15R::_from(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr16(&self) -> MR16R {
        MR16R::_from(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr17(&self) -> MR17R {
        MR17R::_from(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr18(&self) -> MR18R {
        MR18R::_from(((self.bits >> 18) & 0x01) != 0)
    }
    #[doc = "Bit 19 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr19(&self) -> MR19R {
        MR19R::_from(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bit 20 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr20(&self) -> MR20R {
        MR20R::_from(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr21(&self) -> MR21R {
        MR21R::_from(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 22 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr22(&self) -> MR22R {
        MR22R::_from(((self.bits >> 22) & 0x01) != 0)
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr0(&mut self) -> _MR0W {
        _MR0W { w: self }
    }
    #[doc = "Bit 1 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr1(&mut self) -> _MR1W {
        _MR1W { w: self }
    }
    #[doc = "Bit 2 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr2(&mut self) -> _MR2W {
        _MR2W { w: self }
    }
    #[doc = "Bit 3 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr3(&mut self) -> _MR3W {
        _MR3W { w: self }
    }
    #[doc = "Bit 4 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr4(&mut self) -> _MR4W {
        _MR4W { w: self }
    }
    #[doc = "Bit 5 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr5(&mut self) -> _MR5W {
        _MR5W { w: self }
    }
    #[doc = "Bit 6 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr6(&mut self) -> _MR6W {
        _MR6W { w: self }
    }
    #[doc = "Bit 7 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr7(&mut self) -> _MR7W {
        _MR7W { w: self }
    }
    #[doc = "Bit 8 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr8(&mut self) -> _MR8W {
        _MR8W { w: self }
    }
    #[doc = "Bit 9 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr9(&mut self) -> _MR9W {
        _MR9W { w: self }
    }
    #[doc = "Bit 10 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr10(&mut self) -> _MR10W {
        _MR10W { w: self }
    }
    #[doc = "Bit 11 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr11(&mut self) -> _MR11W {
        _MR11W { w: self }
    }
    #[doc = "Bit 12 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr12(&mut self) -> _MR12W {
        _MR12W { w: self }
    }
    #[doc = "Bit 13 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr13(&mut self) -> _MR13W {
        _MR13W { w: self }
    }
    #[doc = "Bit 14 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr14(&mut self) -> _MR14W {
        _MR14W { w: self }
    }
    #[doc = "Bit 15 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr15(&mut self) -> _MR15W {
        _MR15W { w: self }
    }
    #[doc = "Bit 16 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr16(&mut self) -> _MR16W {
        _MR16W { w: self }
    }
    #[doc = "Bit 17 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr17(&mut self) -> _MR17W {
        _MR17W { w: self }
    }
    #[doc = "Bit 18 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr18(&mut self) -> _MR18W {
        _MR18W { w: self }
    }
    #[doc = "Bit 19 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr19(&mut self) -> _MR19W {
        _MR19W { w: self }
    }
    #[doc = "Bit 20 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr20(&mut self) -> _MR20W {
        _MR20W { w: self }
    }
    #[doc = "Bit 21 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr21(&mut self) -> _MR21W {
        _MR21W { w: self }
    }
    #[doc = "Bit 22 - Interrupt mask on line x"]
    #[inline(always)]
    pub fn mr22(&mut self) -> _MR22W {
        _MR22W { w: self }
    }
}
