#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::PR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = "Possible values of the field `PR0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PR0R {
    #[doc = "No trigger request occurred"]
    NOTPENDING,
    #[doc = "Selected trigger request occurred"]
    PENDING,
}
impl PR0R {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            PR0R::NOTPENDING => false,
            PR0R::PENDING => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> PR0R {
        match value {
            false => PR0R::NOTPENDING,
            true => PR0R::PENDING,
        }
    }
    #[doc = "Checks if the value of the field is `NOTPENDING`"]
    #[inline(always)]
    pub fn is_not_pending(&self) -> bool {
        *self == PR0R::NOTPENDING
    }
    #[doc = "Checks if the value of the field is `PENDING`"]
    #[inline(always)]
    pub fn is_pending(&self) -> bool {
        *self == PR0R::PENDING
    }
}
#[doc = "Values that can be written to the field `PR0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PR0W {
    #[doc = "Clears pending bit"]
    CLEAR,
}
impl PR0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            PR0W::CLEAR => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _PR0W<'a> {
    w: &'a mut W,
}
impl<'a> _PR0W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 0);
        self.w.bits |= ((value as u32) & 0x01) << 0;
        self.w
    }
}
#[doc = "Possible values of the field `PR1`"]
pub type PR1R = PR0R;
#[doc = "Values that can be written to the field `PR1`"]
pub type PR1W = PR0W;
#[doc = r"Proxy"]
pub struct _PR1W<'a> {
    w: &'a mut W,
}
impl<'a> _PR1W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 1);
        self.w.bits |= ((value as u32) & 0x01) << 1;
        self.w
    }
}
#[doc = "Possible values of the field `PR2`"]
pub type PR2R = PR0R;
#[doc = "Values that can be written to the field `PR2`"]
pub type PR2W = PR0W;
#[doc = r"Proxy"]
pub struct _PR2W<'a> {
    w: &'a mut W,
}
impl<'a> _PR2W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 2);
        self.w.bits |= ((value as u32) & 0x01) << 2;
        self.w
    }
}
#[doc = "Possible values of the field `PR3`"]
pub type PR3R = PR0R;
#[doc = "Values that can be written to the field `PR3`"]
pub type PR3W = PR0W;
#[doc = r"Proxy"]
pub struct _PR3W<'a> {
    w: &'a mut W,
}
impl<'a> _PR3W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 3);
        self.w.bits |= ((value as u32) & 0x01) << 3;
        self.w
    }
}
#[doc = "Possible values of the field `PR4`"]
pub type PR4R = PR0R;
#[doc = "Values that can be written to the field `PR4`"]
pub type PR4W = PR0W;
#[doc = r"Proxy"]
pub struct _PR4W<'a> {
    w: &'a mut W,
}
impl<'a> _PR4W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR4W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 4);
        self.w.bits |= ((value as u32) & 0x01) << 4;
        self.w
    }
}
#[doc = "Possible values of the field `PR5`"]
pub type PR5R = PR0R;
#[doc = "Values that can be written to the field `PR5`"]
pub type PR5W = PR0W;
#[doc = r"Proxy"]
pub struct _PR5W<'a> {
    w: &'a mut W,
}
impl<'a> _PR5W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR5W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 5);
        self.w.bits |= ((value as u32) & 0x01) << 5;
        self.w
    }
}
#[doc = "Possible values of the field `PR6`"]
pub type PR6R = PR0R;
#[doc = "Values that can be written to the field `PR6`"]
pub type PR6W = PR0W;
#[doc = r"Proxy"]
pub struct _PR6W<'a> {
    w: &'a mut W,
}
impl<'a> _PR6W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR6W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 6);
        self.w.bits |= ((value as u32) & 0x01) << 6;
        self.w
    }
}
#[doc = "Possible values of the field `PR7`"]
pub type PR7R = PR0R;
#[doc = "Values that can be written to the field `PR7`"]
pub type PR7W = PR0W;
#[doc = r"Proxy"]
pub struct _PR7W<'a> {
    w: &'a mut W,
}
impl<'a> _PR7W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR7W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 7);
        self.w.bits |= ((value as u32) & 0x01) << 7;
        self.w
    }
}
#[doc = "Possible values of the field `PR8`"]
pub type PR8R = PR0R;
#[doc = "Values that can be written to the field `PR8`"]
pub type PR8W = PR0W;
#[doc = r"Proxy"]
pub struct _PR8W<'a> {
    w: &'a mut W,
}
impl<'a> _PR8W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR8W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 8);
        self.w.bits |= ((value as u32) & 0x01) << 8;
        self.w
    }
}
#[doc = "Possible values of the field `PR9`"]
pub type PR9R = PR0R;
#[doc = "Values that can be written to the field `PR9`"]
pub type PR9W = PR0W;
#[doc = r"Proxy"]
pub struct _PR9W<'a> {
    w: &'a mut W,
}
impl<'a> _PR9W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR9W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 9);
        self.w.bits |= ((value as u32) & 0x01) << 9;
        self.w
    }
}
#[doc = "Possible values of the field `PR10`"]
pub type PR10R = PR0R;
#[doc = "Values that can be written to the field `PR10`"]
pub type PR10W = PR0W;
#[doc = r"Proxy"]
pub struct _PR10W<'a> {
    w: &'a mut W,
}
impl<'a> _PR10W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR10W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 10);
        self.w.bits |= ((value as u32) & 0x01) << 10;
        self.w
    }
}
#[doc = "Possible values of the field `PR11`"]
pub type PR11R = PR0R;
#[doc = "Values that can be written to the field `PR11`"]
pub type PR11W = PR0W;
#[doc = r"Proxy"]
pub struct _PR11W<'a> {
    w: &'a mut W,
}
impl<'a> _PR11W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR11W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 11);
        self.w.bits |= ((value as u32) & 0x01) << 11;
        self.w
    }
}
#[doc = "Possible values of the field `PR12`"]
pub type PR12R = PR0R;
#[doc = "Values that can be written to the field `PR12`"]
pub type PR12W = PR0W;
#[doc = r"Proxy"]
pub struct _PR12W<'a> {
    w: &'a mut W,
}
impl<'a> _PR12W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR12W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 12);
        self.w.bits |= ((value as u32) & 0x01) << 12;
        self.w
    }
}
#[doc = "Possible values of the field `PR13`"]
pub type PR13R = PR0R;
#[doc = "Values that can be written to the field `PR13`"]
pub type PR13W = PR0W;
#[doc = r"Proxy"]
pub struct _PR13W<'a> {
    w: &'a mut W,
}
impl<'a> _PR13W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR13W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 13);
        self.w.bits |= ((value as u32) & 0x01) << 13;
        self.w
    }
}
#[doc = "Possible values of the field `PR14`"]
pub type PR14R = PR0R;
#[doc = "Values that can be written to the field `PR14`"]
pub type PR14W = PR0W;
#[doc = r"Proxy"]
pub struct _PR14W<'a> {
    w: &'a mut W,
}
impl<'a> _PR14W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR14W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 14);
        self.w.bits |= ((value as u32) & 0x01) << 14;
        self.w
    }
}
#[doc = "Possible values of the field `PR15`"]
pub type PR15R = PR0R;
#[doc = "Values that can be written to the field `PR15`"]
pub type PR15W = PR0W;
#[doc = r"Proxy"]
pub struct _PR15W<'a> {
    w: &'a mut W,
}
impl<'a> _PR15W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR15W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 15);
        self.w.bits |= ((value as u32) & 0x01) << 15;
        self.w
    }
}
#[doc = "Possible values of the field `PR16`"]
pub type PR16R = PR0R;
#[doc = "Values that can be written to the field `PR16`"]
pub type PR16W = PR0W;
#[doc = r"Proxy"]
pub struct _PR16W<'a> {
    w: &'a mut W,
}
impl<'a> _PR16W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR16W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 16);
        self.w.bits |= ((value as u32) & 0x01) << 16;
        self.w
    }
}
#[doc = "Possible values of the field `PR17`"]
pub type PR17R = PR0R;
#[doc = "Values that can be written to the field `PR17`"]
pub type PR17W = PR0W;
#[doc = r"Proxy"]
pub struct _PR17W<'a> {
    w: &'a mut W,
}
impl<'a> _PR17W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR17W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 17);
        self.w.bits |= ((value as u32) & 0x01) << 17;
        self.w
    }
}
#[doc = "Possible values of the field `PR18`"]
pub type PR18R = PR0R;
#[doc = "Values that can be written to the field `PR18`"]
pub type PR18W = PR0W;
#[doc = r"Proxy"]
pub struct _PR18W<'a> {
    w: &'a mut W,
}
impl<'a> _PR18W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR18W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 18);
        self.w.bits |= ((value as u32) & 0x01) << 18;
        self.w
    }
}
#[doc = "Possible values of the field `PR19`"]
pub type PR19R = PR0R;
#[doc = "Values that can be written to the field `PR19`"]
pub type PR19W = PR0W;
#[doc = r"Proxy"]
pub struct _PR19W<'a> {
    w: &'a mut W,
}
impl<'a> _PR19W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR19W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 19);
        self.w.bits |= ((value as u32) & 0x01) << 19;
        self.w
    }
}
#[doc = "Possible values of the field `PR20`"]
pub type PR20R = PR0R;
#[doc = "Values that can be written to the field `PR20`"]
pub type PR20W = PR0W;
#[doc = r"Proxy"]
pub struct _PR20W<'a> {
    w: &'a mut W,
}
impl<'a> _PR20W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR20W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 20);
        self.w.bits |= ((value as u32) & 0x01) << 20;
        self.w
    }
}
#[doc = "Possible values of the field `PR21`"]
pub type PR21R = PR0R;
#[doc = "Values that can be written to the field `PR21`"]
pub type PR21W = PR0W;
#[doc = r"Proxy"]
pub struct _PR21W<'a> {
    w: &'a mut W,
}
impl<'a> _PR21W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR21W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 21);
        self.w.bits |= ((value as u32) & 0x01) << 21;
        self.w
    }
}
#[doc = "Possible values of the field `PR22`"]
pub type PR22R = PR0R;
#[doc = "Values that can be written to the field `PR22`"]
pub type PR22W = PR0W;
#[doc = r"Proxy"]
pub struct _PR22W<'a> {
    w: &'a mut W,
}
impl<'a> _PR22W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR22W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clears pending bit"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PR0W::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 22);
        self.w.bits |= ((value as u32) & 0x01) << 22;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Pending bit"]
    #[inline(always)]
    pub fn pr0(&self) -> PR0R {
        PR0R::_from(((self.bits >> 0) & 0x01) != 0)
    }
    #[doc = "Bit 1 - Pending bit"]
    #[inline(always)]
    pub fn pr1(&self) -> PR1R {
        PR1R::_from(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Pending bit"]
    #[inline(always)]
    pub fn pr2(&self) -> PR2R {
        PR2R::_from(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Pending bit"]
    #[inline(always)]
    pub fn pr3(&self) -> PR3R {
        PR3R::_from(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Pending bit"]
    #[inline(always)]
    pub fn pr4(&self) -> PR4R {
        PR4R::_from(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Pending bit"]
    #[inline(always)]
    pub fn pr5(&self) -> PR5R {
        PR5R::_from(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Pending bit"]
    #[inline(always)]
    pub fn pr6(&self) -> PR6R {
        PR6R::_from(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Pending bit"]
    #[inline(always)]
    pub fn pr7(&self) -> PR7R {
        PR7R::_from(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Pending bit"]
    #[inline(always)]
    pub fn pr8(&self) -> PR8R {
        PR8R::_from(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Pending bit"]
    #[inline(always)]
    pub fn pr9(&self) -> PR9R {
        PR9R::_from(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Pending bit"]
    #[inline(always)]
    pub fn pr10(&self) -> PR10R {
        PR10R::_from(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Pending bit"]
    #[inline(always)]
    pub fn pr11(&self) -> PR11R {
        PR11R::_from(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Pending bit"]
    #[inline(always)]
    pub fn pr12(&self) -> PR12R {
        PR12R::_from(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Pending bit"]
    #[inline(always)]
    pub fn pr13(&self) -> PR13R {
        PR13R::_from(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Pending bit"]
    #[inline(always)]
    pub fn pr14(&self) -> PR14R {
        PR14R::_from(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Pending bit"]
    #[inline(always)]
    pub fn pr15(&self) -> PR15R {
        PR15R::_from(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Pending bit"]
    #[inline(always)]
    pub fn pr16(&self) -> PR16R {
        PR16R::_from(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - Pending bit"]
    #[inline(always)]
    pub fn pr17(&self) -> PR17R {
        PR17R::_from(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - Pending bit"]
    #[inline(always)]
    pub fn pr18(&self) -> PR18R {
        PR18R::_from(((self.bits >> 18) & 0x01) != 0)
    }
    #[doc = "Bit 19 - Pending bit"]
    #[inline(always)]
    pub fn pr19(&self) -> PR19R {
        PR19R::_from(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bit 20 - Pending bit"]
    #[inline(always)]
    pub fn pr20(&self) -> PR20R {
        PR20R::_from(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Pending bit"]
    #[inline(always)]
    pub fn pr21(&self) -> PR21R {
        PR21R::_from(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 22 - Pending bit"]
    #[inline(always)]
    pub fn pr22(&self) -> PR22R {
        PR22R::_from(((self.bits >> 22) & 0x01) != 0)
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Pending bit"]
    #[inline(always)]
    pub fn pr0(&mut self) -> _PR0W {
        _PR0W { w: self }
    }
    #[doc = "Bit 1 - Pending bit"]
    #[inline(always)]
    pub fn pr1(&mut self) -> _PR1W {
        _PR1W { w: self }
    }
    #[doc = "Bit 2 - Pending bit"]
    #[inline(always)]
    pub fn pr2(&mut self) -> _PR2W {
        _PR2W { w: self }
    }
    #[doc = "Bit 3 - Pending bit"]
    #[inline(always)]
    pub fn pr3(&mut self) -> _PR3W {
        _PR3W { w: self }
    }
    #[doc = "Bit 4 - Pending bit"]
    #[inline(always)]
    pub fn pr4(&mut self) -> _PR4W {
        _PR4W { w: self }
    }
    #[doc = "Bit 5 - Pending bit"]
    #[inline(always)]
    pub fn pr5(&mut self) -> _PR5W {
        _PR5W { w: self }
    }
    #[doc = "Bit 6 - Pending bit"]
    #[inline(always)]
    pub fn pr6(&mut self) -> _PR6W {
        _PR6W { w: self }
    }
    #[doc = "Bit 7 - Pending bit"]
    #[inline(always)]
    pub fn pr7(&mut self) -> _PR7W {
        _PR7W { w: self }
    }
    #[doc = "Bit 8 - Pending bit"]
    #[inline(always)]
    pub fn pr8(&mut self) -> _PR8W {
        _PR8W { w: self }
    }
    #[doc = "Bit 9 - Pending bit"]
    #[inline(always)]
    pub fn pr9(&mut self) -> _PR9W {
        _PR9W { w: self }
    }
    #[doc = "Bit 10 - Pending bit"]
    #[inline(always)]
    pub fn pr10(&mut self) -> _PR10W {
        _PR10W { w: self }
    }
    #[doc = "Bit 11 - Pending bit"]
    #[inline(always)]
    pub fn pr11(&mut self) -> _PR11W {
        _PR11W { w: self }
    }
    #[doc = "Bit 12 - Pending bit"]
    #[inline(always)]
    pub fn pr12(&mut self) -> _PR12W {
        _PR12W { w: self }
    }
    #[doc = "Bit 13 - Pending bit"]
    #[inline(always)]
    pub fn pr13(&mut self) -> _PR13W {
        _PR13W { w: self }
    }
    #[doc = "Bit 14 - Pending bit"]
    #[inline(always)]
    pub fn pr14(&mut self) -> _PR14W {
        _PR14W { w: self }
    }
    #[doc = "Bit 15 - Pending bit"]
    #[inline(always)]
    pub fn pr15(&mut self) -> _PR15W {
        _PR15W { w: self }
    }
    #[doc = "Bit 16 - Pending bit"]
    #[inline(always)]
    pub fn pr16(&mut self) -> _PR16W {
        _PR16W { w: self }
    }
    #[doc = "Bit 17 - Pending bit"]
    #[inline(always)]
    pub fn pr17(&mut self) -> _PR17W {
        _PR17W { w: self }
    }
    #[doc = "Bit 18 - Pending bit"]
    #[inline(always)]
    pub fn pr18(&mut self) -> _PR18W {
        _PR18W { w: self }
    }
    #[doc = "Bit 19 - Pending bit"]
    #[inline(always)]
    pub fn pr19(&mut self) -> _PR19W {
        _PR19W { w: self }
    }
    #[doc = "Bit 20 - Pending bit"]
    #[inline(always)]
    pub fn pr20(&mut self) -> _PR20W {
        _PR20W { w: self }
    }
    #[doc = "Bit 21 - Pending bit"]
    #[inline(always)]
    pub fn pr21(&mut self) -> _PR21W {
        _PR21W { w: self }
    }
    #[doc = "Bit 22 - Pending bit"]
    #[inline(always)]
    pub fn pr22(&mut self) -> _PR22W {
        _PR22W { w: self }
    }
}
