#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::RTSR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = "Possible values of the field `TR0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TR0R {
    #[doc = "Rising edge trigger is disabled"]
    DISABLED,
    #[doc = "Rising edge trigger is enabled"]
    ENABLED,
}
impl TR0R {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            TR0R::DISABLED => false,
            TR0R::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> TR0R {
        match value {
            false => TR0R::DISABLED,
            true => TR0R::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == TR0R::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == TR0R::ENABLED
    }
}
#[doc = "Values that can be written to the field `TR0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TR0W {
    #[doc = "Rising edge trigger is disabled"]
    DISABLED,
    #[doc = "Rising edge trigger is enabled"]
    ENABLED,
}
impl TR0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            TR0W::DISABLED => false,
            TR0W::ENABLED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _TR0W<'a> {
    w: &'a mut W,
}
impl<'a> _TR0W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 0);
        self.w.bits |= ((value as u32) & 0x01) << 0;
        self.w
    }
}
#[doc = "Possible values of the field `TR1`"]
pub type TR1R = TR0R;
#[doc = "Values that can be written to the field `TR1`"]
pub type TR1W = TR0W;
#[doc = r"Proxy"]
pub struct _TR1W<'a> {
    w: &'a mut W,
}
impl<'a> _TR1W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 1);
        self.w.bits |= ((value as u32) & 0x01) << 1;
        self.w
    }
}
#[doc = "Possible values of the field `TR2`"]
pub type TR2R = TR0R;
#[doc = "Values that can be written to the field `TR2`"]
pub type TR2W = TR0W;
#[doc = r"Proxy"]
pub struct _TR2W<'a> {
    w: &'a mut W,
}
impl<'a> _TR2W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 2);
        self.w.bits |= ((value as u32) & 0x01) << 2;
        self.w
    }
}
#[doc = "Possible values of the field `TR3`"]
pub type TR3R = TR0R;
#[doc = "Values that can be written to the field `TR3`"]
pub type TR3W = TR0W;
#[doc = r"Proxy"]
pub struct _TR3W<'a> {
    w: &'a mut W,
}
impl<'a> _TR3W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 3);
        self.w.bits |= ((value as u32) & 0x01) << 3;
        self.w
    }
}
#[doc = "Possible values of the field `TR4`"]
pub type TR4R = TR0R;
#[doc = "Values that can be written to the field `TR4`"]
pub type TR4W = TR0W;
#[doc = r"Proxy"]
pub struct _TR4W<'a> {
    w: &'a mut W,
}
impl<'a> _TR4W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR4W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 4);
        self.w.bits |= ((value as u32) & 0x01) << 4;
        self.w
    }
}
#[doc = "Possible values of the field `TR5`"]
pub type TR5R = TR0R;
#[doc = "Values that can be written to the field `TR5`"]
pub type TR5W = TR0W;
#[doc = r"Proxy"]
pub struct _TR5W<'a> {
    w: &'a mut W,
}
impl<'a> _TR5W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR5W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 5);
        self.w.bits |= ((value as u32) & 0x01) << 5;
        self.w
    }
}
#[doc = "Possible values of the field `TR6`"]
pub type TR6R = TR0R;
#[doc = "Values that can be written to the field `TR6`"]
pub type TR6W = TR0W;
#[doc = r"Proxy"]
pub struct _TR6W<'a> {
    w: &'a mut W,
}
impl<'a> _TR6W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR6W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 6);
        self.w.bits |= ((value as u32) & 0x01) << 6;
        self.w
    }
}
#[doc = "Possible values of the field `TR7`"]
pub type TR7R = TR0R;
#[doc = "Values that can be written to the field `TR7`"]
pub type TR7W = TR0W;
#[doc = r"Proxy"]
pub struct _TR7W<'a> {
    w: &'a mut W,
}
impl<'a> _TR7W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR7W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 7);
        self.w.bits |= ((value as u32) & 0x01) << 7;
        self.w
    }
}
#[doc = "Possible values of the field `TR8`"]
pub type TR8R = TR0R;
#[doc = "Values that can be written to the field `TR8`"]
pub type TR8W = TR0W;
#[doc = r"Proxy"]
pub struct _TR8W<'a> {
    w: &'a mut W,
}
impl<'a> _TR8W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR8W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 8);
        self.w.bits |= ((value as u32) & 0x01) << 8;
        self.w
    }
}
#[doc = "Possible values of the field `TR9`"]
pub type TR9R = TR0R;
#[doc = "Values that can be written to the field `TR9`"]
pub type TR9W = TR0W;
#[doc = r"Proxy"]
pub struct _TR9W<'a> {
    w: &'a mut W,
}
impl<'a> _TR9W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR9W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 9);
        self.w.bits |= ((value as u32) & 0x01) << 9;
        self.w
    }
}
#[doc = "Possible values of the field `TR10`"]
pub type TR10R = TR0R;
#[doc = "Values that can be written to the field `TR10`"]
pub type TR10W = TR0W;
#[doc = r"Proxy"]
pub struct _TR10W<'a> {
    w: &'a mut W,
}
impl<'a> _TR10W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR10W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 10);
        self.w.bits |= ((value as u32) & 0x01) << 10;
        self.w
    }
}
#[doc = "Possible values of the field `TR11`"]
pub type TR11R = TR0R;
#[doc = "Values that can be written to the field `TR11`"]
pub type TR11W = TR0W;
#[doc = r"Proxy"]
pub struct _TR11W<'a> {
    w: &'a mut W,
}
impl<'a> _TR11W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR11W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 11);
        self.w.bits |= ((value as u32) & 0x01) << 11;
        self.w
    }
}
#[doc = "Possible values of the field `TR12`"]
pub type TR12R = TR0R;
#[doc = "Values that can be written to the field `TR12`"]
pub type TR12W = TR0W;
#[doc = r"Proxy"]
pub struct _TR12W<'a> {
    w: &'a mut W,
}
impl<'a> _TR12W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR12W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 12);
        self.w.bits |= ((value as u32) & 0x01) << 12;
        self.w
    }
}
#[doc = "Possible values of the field `TR13`"]
pub type TR13R = TR0R;
#[doc = "Values that can be written to the field `TR13`"]
pub type TR13W = TR0W;
#[doc = r"Proxy"]
pub struct _TR13W<'a> {
    w: &'a mut W,
}
impl<'a> _TR13W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR13W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 13);
        self.w.bits |= ((value as u32) & 0x01) << 13;
        self.w
    }
}
#[doc = "Possible values of the field `TR14`"]
pub type TR14R = TR0R;
#[doc = "Values that can be written to the field `TR14`"]
pub type TR14W = TR0W;
#[doc = r"Proxy"]
pub struct _TR14W<'a> {
    w: &'a mut W,
}
impl<'a> _TR14W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR14W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 14);
        self.w.bits |= ((value as u32) & 0x01) << 14;
        self.w
    }
}
#[doc = "Possible values of the field `TR15`"]
pub type TR15R = TR0R;
#[doc = "Values that can be written to the field `TR15`"]
pub type TR15W = TR0W;
#[doc = r"Proxy"]
pub struct _TR15W<'a> {
    w: &'a mut W,
}
impl<'a> _TR15W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR15W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 15);
        self.w.bits |= ((value as u32) & 0x01) << 15;
        self.w
    }
}
#[doc = "Possible values of the field `TR16`"]
pub type TR16R = TR0R;
#[doc = "Values that can be written to the field `TR16`"]
pub type TR16W = TR0W;
#[doc = r"Proxy"]
pub struct _TR16W<'a> {
    w: &'a mut W,
}
impl<'a> _TR16W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR16W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 16);
        self.w.bits |= ((value as u32) & 0x01) << 16;
        self.w
    }
}
#[doc = "Possible values of the field `TR17`"]
pub type TR17R = TR0R;
#[doc = "Values that can be written to the field `TR17`"]
pub type TR17W = TR0W;
#[doc = r"Proxy"]
pub struct _TR17W<'a> {
    w: &'a mut W,
}
impl<'a> _TR17W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR17W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 17);
        self.w.bits |= ((value as u32) & 0x01) << 17;
        self.w
    }
}
#[doc = "Possible values of the field `TR18`"]
pub type TR18R = TR0R;
#[doc = "Values that can be written to the field `TR18`"]
pub type TR18W = TR0W;
#[doc = r"Proxy"]
pub struct _TR18W<'a> {
    w: &'a mut W,
}
impl<'a> _TR18W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR18W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 18);
        self.w.bits |= ((value as u32) & 0x01) << 18;
        self.w
    }
}
#[doc = "Possible values of the field `TR19`"]
pub type TR19R = TR0R;
#[doc = "Values that can be written to the field `TR19`"]
pub type TR19W = TR0W;
#[doc = r"Proxy"]
pub struct _TR19W<'a> {
    w: &'a mut W,
}
impl<'a> _TR19W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR19W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 19);
        self.w.bits |= ((value as u32) & 0x01) << 19;
        self.w
    }
}
#[doc = "Possible values of the field `TR20`"]
pub type TR20R = TR0R;
#[doc = "Values that can be written to the field `TR20`"]
pub type TR20W = TR0W;
#[doc = r"Proxy"]
pub struct _TR20W<'a> {
    w: &'a mut W,
}
impl<'a> _TR20W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR20W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 20);
        self.w.bits |= ((value as u32) & 0x01) << 20;
        self.w
    }
}
#[doc = "Possible values of the field `TR21`"]
pub type TR21R = TR0R;
#[doc = "Values that can be written to the field `TR21`"]
pub type TR21W = TR0W;
#[doc = r"Proxy"]
pub struct _TR21W<'a> {
    w: &'a mut W,
}
impl<'a> _TR21W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR21W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 21);
        self.w.bits |= ((value as u32) & 0x01) << 21;
        self.w
    }
}
#[doc = "Possible values of the field `TR22`"]
pub type TR22R = TR0R;
#[doc = "Values that can be written to the field `TR22`"]
pub type TR22W = TR0W;
#[doc = r"Proxy"]
pub struct _TR22W<'a> {
    w: &'a mut W,
}
impl<'a> _TR22W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TR22W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Rising edge trigger is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TR0W::DISABLED)
    }
    #[doc = "Rising edge trigger is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TR0W::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 22);
        self.w.bits |= ((value as u32) & 0x01) << 22;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr0(&self) -> TR0R {
        TR0R::_from(((self.bits >> 0) & 0x01) != 0)
    }
    #[doc = "Bit 1 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr1(&self) -> TR1R {
        TR1R::_from(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr2(&self) -> TR2R {
        TR2R::_from(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr3(&self) -> TR3R {
        TR3R::_from(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr4(&self) -> TR4R {
        TR4R::_from(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr5(&self) -> TR5R {
        TR5R::_from(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr6(&self) -> TR6R {
        TR6R::_from(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr7(&self) -> TR7R {
        TR7R::_from(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr8(&self) -> TR8R {
        TR8R::_from(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr9(&self) -> TR9R {
        TR9R::_from(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr10(&self) -> TR10R {
        TR10R::_from(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr11(&self) -> TR11R {
        TR11R::_from(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr12(&self) -> TR12R {
        TR12R::_from(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr13(&self) -> TR13R {
        TR13R::_from(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr14(&self) -> TR14R {
        TR14R::_from(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr15(&self) -> TR15R {
        TR15R::_from(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr16(&self) -> TR16R {
        TR16R::_from(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr17(&self) -> TR17R {
        TR17R::_from(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr18(&self) -> TR18R {
        TR18R::_from(((self.bits >> 18) & 0x01) != 0)
    }
    #[doc = "Bit 19 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr19(&self) -> TR19R {
        TR19R::_from(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bit 20 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr20(&self) -> TR20R {
        TR20R::_from(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr21(&self) -> TR21R {
        TR21R::_from(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 22 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr22(&self) -> TR22R {
        TR22R::_from(((self.bits >> 22) & 0x01) != 0)
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr0(&mut self) -> _TR0W {
        _TR0W { w: self }
    }
    #[doc = "Bit 1 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr1(&mut self) -> _TR1W {
        _TR1W { w: self }
    }
    #[doc = "Bit 2 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr2(&mut self) -> _TR2W {
        _TR2W { w: self }
    }
    #[doc = "Bit 3 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr3(&mut self) -> _TR3W {
        _TR3W { w: self }
    }
    #[doc = "Bit 4 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr4(&mut self) -> _TR4W {
        _TR4W { w: self }
    }
    #[doc = "Bit 5 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr5(&mut self) -> _TR5W {
        _TR5W { w: self }
    }
    #[doc = "Bit 6 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr6(&mut self) -> _TR6W {
        _TR6W { w: self }
    }
    #[doc = "Bit 7 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr7(&mut self) -> _TR7W {
        _TR7W { w: self }
    }
    #[doc = "Bit 8 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr8(&mut self) -> _TR8W {
        _TR8W { w: self }
    }
    #[doc = "Bit 9 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr9(&mut self) -> _TR9W {
        _TR9W { w: self }
    }
    #[doc = "Bit 10 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr10(&mut self) -> _TR10W {
        _TR10W { w: self }
    }
    #[doc = "Bit 11 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr11(&mut self) -> _TR11W {
        _TR11W { w: self }
    }
    #[doc = "Bit 12 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr12(&mut self) -> _TR12W {
        _TR12W { w: self }
    }
    #[doc = "Bit 13 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr13(&mut self) -> _TR13W {
        _TR13W { w: self }
    }
    #[doc = "Bit 14 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr14(&mut self) -> _TR14W {
        _TR14W { w: self }
    }
    #[doc = "Bit 15 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr15(&mut self) -> _TR15W {
        _TR15W { w: self }
    }
    #[doc = "Bit 16 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr16(&mut self) -> _TR16W {
        _TR16W { w: self }
    }
    #[doc = "Bit 17 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr17(&mut self) -> _TR17W {
        _TR17W { w: self }
    }
    #[doc = "Bit 18 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr18(&mut self) -> _TR18W {
        _TR18W { w: self }
    }
    #[doc = "Bit 19 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr19(&mut self) -> _TR19W {
        _TR19W { w: self }
    }
    #[doc = "Bit 20 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr20(&mut self) -> _TR20W {
        _TR20W { w: self }
    }
    #[doc = "Bit 21 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr21(&mut self) -> _TR21W {
        _TR21W { w: self }
    }
    #[doc = "Bit 22 - Rising edge trigger event configuration bit of line x"]
    #[inline(always)]
    pub fn tr22(&mut self) -> _TR22W {
        _TR22W { w: self }
    }
}
