#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SWIER {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = "Possible values of the field `SWIER0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SWIER0R {
    #[doc = "Generates an interrupt request"]
    PEND,
    #[doc = r"Reserved"]
    _Reserved(bool),
}
impl SWIER0R {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            SWIER0R::PEND => true,
            SWIER0R::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> SWIER0R {
        match value {
            true => SWIER0R::PEND,
            i => SWIER0R::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `PEND`"]
    #[inline(always)]
    pub fn is_pend(&self) -> bool {
        *self == SWIER0R::PEND
    }
}
#[doc = "Values that can be written to the field `SWIER0`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SWIER0W {
    #[doc = "Generates an interrupt request"]
    PEND,
}
impl SWIER0W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            SWIER0W::PEND => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _SWIER0W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER0W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER0W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 0);
        self.w.bits |= ((value as u32) & 0x01) << 0;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER1`"]
pub type SWIER1R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER1`"]
pub type SWIER1W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER1W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER1W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER1W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 1);
        self.w.bits |= ((value as u32) & 0x01) << 1;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER2`"]
pub type SWIER2R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER2`"]
pub type SWIER2W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER2W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER2W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER2W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 2);
        self.w.bits |= ((value as u32) & 0x01) << 2;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER3`"]
pub type SWIER3R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER3`"]
pub type SWIER3W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER3W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER3W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER3W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 3);
        self.w.bits |= ((value as u32) & 0x01) << 3;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER4`"]
pub type SWIER4R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER4`"]
pub type SWIER4W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER4W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER4W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER4W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 4);
        self.w.bits |= ((value as u32) & 0x01) << 4;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER5`"]
pub type SWIER5R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER5`"]
pub type SWIER5W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER5W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER5W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER5W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 5);
        self.w.bits |= ((value as u32) & 0x01) << 5;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER6`"]
pub type SWIER6R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER6`"]
pub type SWIER6W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER6W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER6W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER6W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 6);
        self.w.bits |= ((value as u32) & 0x01) << 6;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER7`"]
pub type SWIER7R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER7`"]
pub type SWIER7W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER7W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER7W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER7W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 7);
        self.w.bits |= ((value as u32) & 0x01) << 7;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER8`"]
pub type SWIER8R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER8`"]
pub type SWIER8W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER8W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER8W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER8W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 8);
        self.w.bits |= ((value as u32) & 0x01) << 8;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER9`"]
pub type SWIER9R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER9`"]
pub type SWIER9W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER9W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER9W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER9W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 9);
        self.w.bits |= ((value as u32) & 0x01) << 9;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER10`"]
pub type SWIER10R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER10`"]
pub type SWIER10W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER10W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER10W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER10W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 10);
        self.w.bits |= ((value as u32) & 0x01) << 10;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER11`"]
pub type SWIER11R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER11`"]
pub type SWIER11W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER11W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER11W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER11W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 11);
        self.w.bits |= ((value as u32) & 0x01) << 11;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER12`"]
pub type SWIER12R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER12`"]
pub type SWIER12W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER12W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER12W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER12W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 12);
        self.w.bits |= ((value as u32) & 0x01) << 12;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER13`"]
pub type SWIER13R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER13`"]
pub type SWIER13W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER13W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER13W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER13W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 13);
        self.w.bits |= ((value as u32) & 0x01) << 13;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER14`"]
pub type SWIER14R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER14`"]
pub type SWIER14W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER14W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER14W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER14W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 14);
        self.w.bits |= ((value as u32) & 0x01) << 14;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER15`"]
pub type SWIER15R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER15`"]
pub type SWIER15W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER15W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER15W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER15W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 15);
        self.w.bits |= ((value as u32) & 0x01) << 15;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER16`"]
pub type SWIER16R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER16`"]
pub type SWIER16W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER16W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER16W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER16W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 16);
        self.w.bits |= ((value as u32) & 0x01) << 16;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER17`"]
pub type SWIER17R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER17`"]
pub type SWIER17W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER17W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER17W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER17W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 17);
        self.w.bits |= ((value as u32) & 0x01) << 17;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER18`"]
pub type SWIER18R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER18`"]
pub type SWIER18W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER18W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER18W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER18W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 18);
        self.w.bits |= ((value as u32) & 0x01) << 18;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER19`"]
pub type SWIER19R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER19`"]
pub type SWIER19W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER19W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER19W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER19W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 19);
        self.w.bits |= ((value as u32) & 0x01) << 19;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER20`"]
pub type SWIER20R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER20`"]
pub type SWIER20W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER20W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER20W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER20W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 20);
        self.w.bits |= ((value as u32) & 0x01) << 20;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER21`"]
pub type SWIER21R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER21`"]
pub type SWIER21W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER21W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER21W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER21W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 21);
        self.w.bits |= ((value as u32) & 0x01) << 21;
        self.w
    }
}
#[doc = "Possible values of the field `SWIER22`"]
pub type SWIER22R = SWIER0R;
#[doc = "Values that can be written to the field `SWIER22`"]
pub type SWIER22W = SWIER0W;
#[doc = r"Proxy"]
pub struct _SWIER22W<'a> {
    w: &'a mut W,
}
impl<'a> _SWIER22W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIER22W) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Generates an interrupt request"]
    #[inline(always)]
    pub fn pend(self) -> &'a mut W {
        self.variant(SWIER0W::PEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 22);
        self.w.bits |= ((value as u32) & 0x01) << 22;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier0(&self) -> SWIER0R {
        SWIER0R::_from(((self.bits >> 0) & 0x01) != 0)
    }
    #[doc = "Bit 1 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier1(&self) -> SWIER1R {
        SWIER1R::_from(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier2(&self) -> SWIER2R {
        SWIER2R::_from(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier3(&self) -> SWIER3R {
        SWIER3R::_from(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier4(&self) -> SWIER4R {
        SWIER4R::_from(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier5(&self) -> SWIER5R {
        SWIER5R::_from(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier6(&self) -> SWIER6R {
        SWIER6R::_from(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier7(&self) -> SWIER7R {
        SWIER7R::_from(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier8(&self) -> SWIER8R {
        SWIER8R::_from(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier9(&self) -> SWIER9R {
        SWIER9R::_from(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier10(&self) -> SWIER10R {
        SWIER10R::_from(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier11(&self) -> SWIER11R {
        SWIER11R::_from(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier12(&self) -> SWIER12R {
        SWIER12R::_from(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier13(&self) -> SWIER13R {
        SWIER13R::_from(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier14(&self) -> SWIER14R {
        SWIER14R::_from(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier15(&self) -> SWIER15R {
        SWIER15R::_from(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier16(&self) -> SWIER16R {
        SWIER16R::_from(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier17(&self) -> SWIER17R {
        SWIER17R::_from(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier18(&self) -> SWIER18R {
        SWIER18R::_from(((self.bits >> 18) & 0x01) != 0)
    }
    #[doc = "Bit 19 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier19(&self) -> SWIER19R {
        SWIER19R::_from(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bit 20 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier20(&self) -> SWIER20R {
        SWIER20R::_from(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier21(&self) -> SWIER21R {
        SWIER21R::_from(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 22 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier22(&self) -> SWIER22R {
        SWIER22R::_from(((self.bits >> 22) & 0x01) != 0)
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier0(&mut self) -> _SWIER0W {
        _SWIER0W { w: self }
    }
    #[doc = "Bit 1 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier1(&mut self) -> _SWIER1W {
        _SWIER1W { w: self }
    }
    #[doc = "Bit 2 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier2(&mut self) -> _SWIER2W {
        _SWIER2W { w: self }
    }
    #[doc = "Bit 3 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier3(&mut self) -> _SWIER3W {
        _SWIER3W { w: self }
    }
    #[doc = "Bit 4 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier4(&mut self) -> _SWIER4W {
        _SWIER4W { w: self }
    }
    #[doc = "Bit 5 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier5(&mut self) -> _SWIER5W {
        _SWIER5W { w: self }
    }
    #[doc = "Bit 6 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier6(&mut self) -> _SWIER6W {
        _SWIER6W { w: self }
    }
    #[doc = "Bit 7 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier7(&mut self) -> _SWIER7W {
        _SWIER7W { w: self }
    }
    #[doc = "Bit 8 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier8(&mut self) -> _SWIER8W {
        _SWIER8W { w: self }
    }
    #[doc = "Bit 9 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier9(&mut self) -> _SWIER9W {
        _SWIER9W { w: self }
    }
    #[doc = "Bit 10 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier10(&mut self) -> _SWIER10W {
        _SWIER10W { w: self }
    }
    #[doc = "Bit 11 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier11(&mut self) -> _SWIER11W {
        _SWIER11W { w: self }
    }
    #[doc = "Bit 12 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier12(&mut self) -> _SWIER12W {
        _SWIER12W { w: self }
    }
    #[doc = "Bit 13 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier13(&mut self) -> _SWIER13W {
        _SWIER13W { w: self }
    }
    #[doc = "Bit 14 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier14(&mut self) -> _SWIER14W {
        _SWIER14W { w: self }
    }
    #[doc = "Bit 15 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier15(&mut self) -> _SWIER15W {
        _SWIER15W { w: self }
    }
    #[doc = "Bit 16 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier16(&mut self) -> _SWIER16W {
        _SWIER16W { w: self }
    }
    #[doc = "Bit 17 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier17(&mut self) -> _SWIER17W {
        _SWIER17W { w: self }
    }
    #[doc = "Bit 18 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier18(&mut self) -> _SWIER18W {
        _SWIER18W { w: self }
    }
    #[doc = "Bit 19 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier19(&mut self) -> _SWIER19W {
        _SWIER19W { w: self }
    }
    #[doc = "Bit 20 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier20(&mut self) -> _SWIER20W {
        _SWIER20W { w: self }
    }
    #[doc = "Bit 21 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier21(&mut self) -> _SWIER21W {
        _SWIER21W { w: self }
    }
    #[doc = "Bit 22 - Software interrupt on line x"]
    #[inline(always)]
    pub fn swier22(&mut self) -> _SWIER22W {
        _SWIER22W { w: self }
    }
}
