#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
impl super::IDR {
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
}
#[doc = "Possible values of the field `IDR15`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum IDR15R {
    #[doc = "Input is logic high"]
    HIGH,
    #[doc = "Input is logic low"]
    LOW,
}
impl IDR15R {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            IDR15R::HIGH => true,
            IDR15R::LOW => false,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> IDR15R {
        match value {
            true => IDR15R::HIGH,
            false => IDR15R::LOW,
        }
    }
    #[doc = "Checks if the value of the field is `HIGH`"]
    #[inline(always)]
    pub fn is_high(&self) -> bool {
        *self == IDR15R::HIGH
    }
    #[doc = "Checks if the value of the field is `LOW`"]
    #[inline(always)]
    pub fn is_low(&self) -> bool {
        *self == IDR15R::LOW
    }
}
#[doc = "Possible values of the field `IDR14`"]
pub type IDR14R = IDR15R;
#[doc = "Possible values of the field `IDR13`"]
pub type IDR13R = IDR15R;
#[doc = "Possible values of the field `IDR12`"]
pub type IDR12R = IDR15R;
#[doc = "Possible values of the field `IDR11`"]
pub type IDR11R = IDR15R;
#[doc = "Possible values of the field `IDR10`"]
pub type IDR10R = IDR15R;
#[doc = "Possible values of the field `IDR9`"]
pub type IDR9R = IDR15R;
#[doc = "Possible values of the field `IDR8`"]
pub type IDR8R = IDR15R;
#[doc = "Possible values of the field `IDR7`"]
pub type IDR7R = IDR15R;
#[doc = "Possible values of the field `IDR6`"]
pub type IDR6R = IDR15R;
#[doc = "Possible values of the field `IDR5`"]
pub type IDR5R = IDR15R;
#[doc = "Possible values of the field `IDR4`"]
pub type IDR4R = IDR15R;
#[doc = "Possible values of the field `IDR3`"]
pub type IDR3R = IDR15R;
#[doc = "Possible values of the field `IDR2`"]
pub type IDR2R = IDR15R;
#[doc = "Possible values of the field `IDR1`"]
pub type IDR1R = IDR15R;
#[doc = "Possible values of the field `IDR0`"]
pub type IDR0R = IDR15R;
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 15 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr15(&self) -> IDR15R {
        IDR15R::_from(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr14(&self) -> IDR14R {
        IDR14R::_from(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr13(&self) -> IDR13R {
        IDR13R::_from(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr12(&self) -> IDR12R {
        IDR12R::_from(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr11(&self) -> IDR11R {
        IDR11R::_from(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr10(&self) -> IDR10R {
        IDR10R::_from(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr9(&self) -> IDR9R {
        IDR9R::_from(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr8(&self) -> IDR8R {
        IDR8R::_from(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr7(&self) -> IDR7R {
        IDR7R::_from(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr6(&self) -> IDR6R {
        IDR6R::_from(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr5(&self) -> IDR5R {
        IDR5R::_from(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr4(&self) -> IDR4R {
        IDR4R::_from(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr3(&self) -> IDR3R {
        IDR3R::_from(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr2(&self) -> IDR2R {
        IDR2R::_from(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 1 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr1(&self) -> IDR1R {
        IDR1R::_from(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 0 - Port input data (y = 0..15)"]
    #[inline(always)]
    pub fn idr0(&self) -> IDR0R {
        IDR0R::_from(((self.bits >> 0) & 0x01) != 0)
    }
}
