#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - control/status register"]
    pub csr: CSR,
    #[doc = "0x04 - offset trimming register for normal mode"]
    pub otr: OTR,
    #[doc = "0x08 - OPAMP offset trimming register for low power mode"]
    pub lpotr: LPOTR,
}
#[doc = "control/status register"]
pub struct CSR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "control/status register"]
pub mod csr;
#[doc = "offset trimming register for normal mode"]
pub struct OTR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "offset trimming register for normal mode"]
pub mod otr;
#[doc = "OPAMP offset trimming register for low power mode"]
pub struct LPOTR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "OPAMP offset trimming register for low power mode"]
pub mod lpotr;
