#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::OTR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct OT_USERR {
    bits: bool,
}
impl OT_USERR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OT_USERW<'a> {
    w: &'a mut W,
}
impl<'a> _OT_USERW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 31);
        self.w.bits |= ((value as u32) & 0x01) << 31;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct AO3_OPT_OFFSET_TRIMR {
    bits: u16,
}
impl AO3_OPT_OFFSET_TRIMR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _AO3_OPT_OFFSET_TRIMW<'a> {
    w: &'a mut W,
}
impl<'a> _AO3_OPT_OFFSET_TRIMW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits &= !(0x03ff << 20);
        self.w.bits |= ((value as u32) & 0x03ff) << 20;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct AO2_OPT_OFFSET_TRIMR {
    bits: u16,
}
impl AO2_OPT_OFFSET_TRIMR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _AO2_OPT_OFFSET_TRIMW<'a> {
    w: &'a mut W,
}
impl<'a> _AO2_OPT_OFFSET_TRIMW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits &= !(0x03ff << 10);
        self.w.bits |= ((value as u32) & 0x03ff) << 10;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct AO1_OPT_OFFSET_TRIMR {
    bits: u16,
}
impl AO1_OPT_OFFSET_TRIMR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _AO1_OPT_OFFSET_TRIMW<'a> {
    w: &'a mut W,
}
impl<'a> _AO1_OPT_OFFSET_TRIMW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits &= !(0x03ff << 0);
        self.w.bits |= ((value as u32) & 0x03ff) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 31 - Select user or factory trimming value"]
    #[inline(always)]
    pub fn ot_user(&self) -> OT_USERR {
        let bits = ((self.bits >> 31) & 0x01) != 0;
        OT_USERR { bits }
    }
    #[doc = "Bits 20:29 - OPAMP3, 10-bit offset trim value for normal mode"]
    #[inline(always)]
    pub fn ao3_opt_offset_trim(&self) -> AO3_OPT_OFFSET_TRIMR {
        let bits = ((self.bits >> 20) & 0x03ff) as u16;
        AO3_OPT_OFFSET_TRIMR { bits }
    }
    #[doc = "Bits 10:19 - OPAMP2, 10-bit offset trim value for normal mode"]
    #[inline(always)]
    pub fn ao2_opt_offset_trim(&self) -> AO2_OPT_OFFSET_TRIMR {
        let bits = ((self.bits >> 10) & 0x03ff) as u16;
        AO2_OPT_OFFSET_TRIMR { bits }
    }
    #[doc = "Bits 0:9 - OPAMP1, 10-bit offset trim value for normal mode"]
    #[inline(always)]
    pub fn ao1_opt_offset_trim(&self) -> AO1_OPT_OFFSET_TRIMR {
        let bits = ((self.bits >> 0) & 0x03ff) as u16;
        AO1_OPT_OFFSET_TRIMR { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 31 - Select user or factory trimming value"]
    #[inline(always)]
    pub fn ot_user(&mut self) -> _OT_USERW {
        _OT_USERW { w: self }
    }
    #[doc = "Bits 20:29 - OPAMP3, 10-bit offset trim value for normal mode"]
    #[inline(always)]
    pub fn ao3_opt_offset_trim(&mut self) -> _AO3_OPT_OFFSET_TRIMW {
        _AO3_OPT_OFFSET_TRIMW { w: self }
    }
    #[doc = "Bits 10:19 - OPAMP2, 10-bit offset trim value for normal mode"]
    #[inline(always)]
    pub fn ao2_opt_offset_trim(&mut self) -> _AO2_OPT_OFFSET_TRIMW {
        _AO2_OPT_OFFSET_TRIMW { w: self }
    }
    #[doc = "Bits 0:9 - OPAMP1, 10-bit offset trim value for normal mode"]
    #[inline(always)]
    pub fn ao1_opt_offset_trim(&mut self) -> _AO1_OPT_OFFSET_TRIMW {
        _AO1_OPT_OFFSET_TRIMW { w: self }
    }
}
