#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SQR1 {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct LR {
    bits: u8,
}
impl LR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _LW<'a> {
    w: &'a mut W,
}
impl<'a> _LW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x0f << 20);
        self.w.bits |= ((value as u32) & 0x0f) << 20;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ28R {
    bits: u8,
}
impl SQ28R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ28W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ28W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 15);
        self.w.bits |= ((value as u32) & 0x1f) << 15;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ27R {
    bits: u8,
}
impl SQ27R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ27W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ27W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 10);
        self.w.bits |= ((value as u32) & 0x1f) << 10;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ26R {
    bits: u8,
}
impl SQ26R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ26W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ26W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 5);
        self.w.bits |= ((value as u32) & 0x1f) << 5;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ25R {
    bits: u8,
}
impl SQ25R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ25W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ25W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 0);
        self.w.bits |= ((value as u32) & 0x1f) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 20:23 - Regular channel sequence length"]
    #[inline(always)]
    pub fn l(&self) -> LR {
        let bits = ((self.bits >> 20) & 0x0f) as u8;
        LR { bits }
    }
    #[doc = "Bits 15:19 - 28th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq28(&self) -> SQ28R {
        let bits = ((self.bits >> 15) & 0x1f) as u8;
        SQ28R { bits }
    }
    #[doc = "Bits 10:14 - 27th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq27(&self) -> SQ27R {
        let bits = ((self.bits >> 10) & 0x1f) as u8;
        SQ27R { bits }
    }
    #[doc = "Bits 5:9 - 26th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq26(&self) -> SQ26R {
        let bits = ((self.bits >> 5) & 0x1f) as u8;
        SQ26R { bits }
    }
    #[doc = "Bits 0:4 - 25th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq25(&self) -> SQ25R {
        let bits = ((self.bits >> 0) & 0x1f) as u8;
        SQ25R { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 20:23 - Regular channel sequence length"]
    #[inline(always)]
    pub fn l(&mut self) -> _LW {
        _LW { w: self }
    }
    #[doc = "Bits 15:19 - 28th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq28(&mut self) -> _SQ28W {
        _SQ28W { w: self }
    }
    #[doc = "Bits 10:14 - 27th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq27(&mut self) -> _SQ27W {
        _SQ27W { w: self }
    }
    #[doc = "Bits 5:9 - 26th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq26(&mut self) -> _SQ26W {
        _SQ26W { w: self }
    }
    #[doc = "Bits 0:4 - 25th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq25(&mut self) -> _SQ25W {
        _SQ25W { w: self }
    }
}
