#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SQR2 {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct SQ24R {
    bits: u8,
}
impl SQ24R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ24W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ24W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 25);
        self.w.bits |= ((value as u32) & 0x1f) << 25;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ23R {
    bits: u8,
}
impl SQ23R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ23W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ23W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 20);
        self.w.bits |= ((value as u32) & 0x1f) << 20;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ22R {
    bits: u8,
}
impl SQ22R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ22W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ22W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 15);
        self.w.bits |= ((value as u32) & 0x1f) << 15;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ21R {
    bits: u8,
}
impl SQ21R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ21W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ21W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 10);
        self.w.bits |= ((value as u32) & 0x1f) << 10;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ20R {
    bits: u8,
}
impl SQ20R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ20W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ20W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 5);
        self.w.bits |= ((value as u32) & 0x1f) << 5;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ19R {
    bits: u8,
}
impl SQ19R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ19W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ19W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 0);
        self.w.bits |= ((value as u32) & 0x1f) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 25:29 - 24th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq24(&self) -> SQ24R {
        let bits = ((self.bits >> 25) & 0x1f) as u8;
        SQ24R { bits }
    }
    #[doc = "Bits 20:24 - 23rd conversion in regular sequence"]
    #[inline(always)]
    pub fn sq23(&self) -> SQ23R {
        let bits = ((self.bits >> 20) & 0x1f) as u8;
        SQ23R { bits }
    }
    #[doc = "Bits 15:19 - 22nd conversion in regular sequence"]
    #[inline(always)]
    pub fn sq22(&self) -> SQ22R {
        let bits = ((self.bits >> 15) & 0x1f) as u8;
        SQ22R { bits }
    }
    #[doc = "Bits 10:14 - 21st conversion in regular sequence"]
    #[inline(always)]
    pub fn sq21(&self) -> SQ21R {
        let bits = ((self.bits >> 10) & 0x1f) as u8;
        SQ21R { bits }
    }
    #[doc = "Bits 5:9 - 20th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq20(&self) -> SQ20R {
        let bits = ((self.bits >> 5) & 0x1f) as u8;
        SQ20R { bits }
    }
    #[doc = "Bits 0:4 - 19th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq19(&self) -> SQ19R {
        let bits = ((self.bits >> 0) & 0x1f) as u8;
        SQ19R { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 25:29 - 24th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq24(&mut self) -> _SQ24W {
        _SQ24W { w: self }
    }
    #[doc = "Bits 20:24 - 23rd conversion in regular sequence"]
    #[inline(always)]
    pub fn sq23(&mut self) -> _SQ23W {
        _SQ23W { w: self }
    }
    #[doc = "Bits 15:19 - 22nd conversion in regular sequence"]
    #[inline(always)]
    pub fn sq22(&mut self) -> _SQ22W {
        _SQ22W { w: self }
    }
    #[doc = "Bits 10:14 - 21st conversion in regular sequence"]
    #[inline(always)]
    pub fn sq21(&mut self) -> _SQ21W {
        _SQ21W { w: self }
    }
    #[doc = "Bits 5:9 - 20th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq20(&mut self) -> _SQ20W {
        _SQ20W { w: self }
    }
    #[doc = "Bits 0:4 - 19th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq19(&mut self) -> _SQ19W {
        _SQ19W { w: self }
    }
}
