#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SQR3 {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct SQ18R {
    bits: u8,
}
impl SQ18R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ18W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ18W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 25);
        self.w.bits |= ((value as u32) & 0x1f) << 25;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ17R {
    bits: u8,
}
impl SQ17R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ17W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ17W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 20);
        self.w.bits |= ((value as u32) & 0x1f) << 20;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ16R {
    bits: u8,
}
impl SQ16R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ16W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ16W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 15);
        self.w.bits |= ((value as u32) & 0x1f) << 15;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ15R {
    bits: u8,
}
impl SQ15R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ15W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ15W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 10);
        self.w.bits |= ((value as u32) & 0x1f) << 10;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ14R {
    bits: u8,
}
impl SQ14R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ14W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ14W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 5);
        self.w.bits |= ((value as u32) & 0x1f) << 5;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct SQ13R {
    bits: u8,
}
impl SQ13R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _SQ13W<'a> {
    w: &'a mut W,
}
impl<'a> _SQ13W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x1f << 0);
        self.w.bits |= ((value as u32) & 0x1f) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 25:29 - 18th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq18(&self) -> SQ18R {
        let bits = ((self.bits >> 25) & 0x1f) as u8;
        SQ18R { bits }
    }
    #[doc = "Bits 20:24 - 17th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq17(&self) -> SQ17R {
        let bits = ((self.bits >> 20) & 0x1f) as u8;
        SQ17R { bits }
    }
    #[doc = "Bits 15:19 - 16th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq16(&self) -> SQ16R {
        let bits = ((self.bits >> 15) & 0x1f) as u8;
        SQ16R { bits }
    }
    #[doc = "Bits 10:14 - 15th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq15(&self) -> SQ15R {
        let bits = ((self.bits >> 10) & 0x1f) as u8;
        SQ15R { bits }
    }
    #[doc = "Bits 5:9 - 14th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq14(&self) -> SQ14R {
        let bits = ((self.bits >> 5) & 0x1f) as u8;
        SQ14R { bits }
    }
    #[doc = "Bits 0:4 - 13th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq13(&self) -> SQ13R {
        let bits = ((self.bits >> 0) & 0x1f) as u8;
        SQ13R { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 25:29 - 18th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq18(&mut self) -> _SQ18W {
        _SQ18W { w: self }
    }
    #[doc = "Bits 20:24 - 17th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq17(&mut self) -> _SQ17W {
        _SQ17W { w: self }
    }
    #[doc = "Bits 15:19 - 16th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq16(&mut self) -> _SQ16W {
        _SQ16W { w: self }
    }
    #[doc = "Bits 10:14 - 15th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq15(&mut self) -> _SQ15W {
        _SQ15W { w: self }
    }
    #[doc = "Bits 5:9 - 14th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq14(&mut self) -> _SQ14W {
        _SQ14W { w: self }
    }
    #[doc = "Bits 0:4 - 13th conversion in regular sequence"]
    #[inline(always)]
    pub fn sq13(&mut self) -> _SQ13W {
        _SQ13W { w: self }
    }
}
