#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - control register"]
    pub cr: CR,
    #[doc = "0x04 - Status register"]
    pub sr: SR,
    #[doc = "0x08 - Data input register"]
    pub dinr: DINR,
    #[doc = "0x0c - Data output register"]
    pub doutr: DOUTR,
    #[doc = "0x10 - AES Key register 0"]
    pub keyr0: KEYR0,
    #[doc = "0x14 - AES Key register 1"]
    pub keyr1: KEYR1,
    #[doc = "0x18 - AES Key register 2"]
    pub keyr2: KEYR2,
    #[doc = "0x1c - AES Key register 3"]
    pub keyr3: KEYR3,
    #[doc = "0x20 - Initialization Vector Register 0"]
    pub ivr0: IVR0,
    #[doc = "0x24 - Initialization Vector Register 1"]
    pub ivr1: IVR1,
    #[doc = "0x28 - Initialization Vector Register 2"]
    pub ivr2: IVR2,
    #[doc = "0x2c - Initialization Vector Register 3"]
    pub ivr3: IVR3,
}
#[doc = "control register"]
pub struct CR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "control register"]
pub mod cr;
#[doc = "Status register"]
pub struct SR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "Status register"]
pub mod sr;
#[doc = "Data input register"]
pub struct DINR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "Data input register"]
pub mod dinr;
#[doc = "Data output register"]
pub struct DOUTR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "Data output register"]
pub mod doutr;
#[doc = "AES Key register 0"]
pub struct KEYR0 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "AES Key register 0"]
pub mod keyr0;
#[doc = "AES Key register 1"]
pub struct KEYR1 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "AES Key register 1"]
pub mod keyr1;
#[doc = "AES Key register 2"]
pub struct KEYR2 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "AES Key register 2"]
pub mod keyr2;
#[doc = "AES Key register 3"]
pub struct KEYR3 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "AES Key register 3"]
pub mod keyr3;
#[doc = "Initialization Vector Register 0"]
pub struct IVR0 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "Initialization Vector Register 0"]
pub mod ivr0;
#[doc = "Initialization Vector Register 1"]
pub struct IVR1 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "Initialization Vector Register 1"]
pub mod ivr1;
#[doc = "Initialization Vector Register 2"]
pub struct IVR2 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "Initialization Vector Register 2"]
pub mod ivr2;
#[doc = "Initialization Vector Register 3"]
pub struct IVR3 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "Initialization Vector Register 3"]
pub mod ivr3;
