#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::BCR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = "Possible values of the field `CBURSTRW`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CBURSTRWR {
    #[doc = "Write operations are performed in synchronous mode"]
    ENABLED,
    #[doc = "Write operations are always performed in asynchronous mode"]
    DISABLED,
}
impl CBURSTRWR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            CBURSTRWR::ENABLED => true,
            CBURSTRWR::DISABLED => false,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> CBURSTRWR {
        match value {
            true => CBURSTRWR::ENABLED,
            false => CBURSTRWR::DISABLED,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == CBURSTRWR::ENABLED
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CBURSTRWR::DISABLED
    }
}
#[doc = "Values that can be written to the field `CBURSTRW`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CBURSTRWW {
    #[doc = "Write operations are performed in synchronous mode"]
    ENABLED,
    #[doc = "Write operations are always performed in asynchronous mode"]
    DISABLED,
}
impl CBURSTRWW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            CBURSTRWW::ENABLED => true,
            CBURSTRWW::DISABLED => false,
        }
    }
}
#[doc = r"Proxy"]
pub struct _CBURSTRWW<'a> {
    w: &'a mut W,
}
impl<'a> _CBURSTRWW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CBURSTRWW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Write operations are performed in synchronous mode"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(CBURSTRWW::ENABLED)
    }
    #[doc = "Write operations are always performed in asynchronous mode"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CBURSTRWW::DISABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 19);
        self.w.bits |= ((value as u32) & 0x01) << 19;
        self.w
    }
}
#[doc = "Possible values of the field `ASYNCWAIT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ASYNCWAITR {
    #[doc = "Wait signal not used in asynchronous mode"]
    DISABLED,
    #[doc = "Wait signal used even in asynchronous mode"]
    ENABLED,
}
impl ASYNCWAITR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            ASYNCWAITR::DISABLED => false,
            ASYNCWAITR::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> ASYNCWAITR {
        match value {
            false => ASYNCWAITR::DISABLED,
            true => ASYNCWAITR::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == ASYNCWAITR::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == ASYNCWAITR::ENABLED
    }
}
#[doc = "Values that can be written to the field `ASYNCWAIT`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ASYNCWAITW {
    #[doc = "Wait signal not used in asynchronous mode"]
    DISABLED,
    #[doc = "Wait signal used even in asynchronous mode"]
    ENABLED,
}
impl ASYNCWAITW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            ASYNCWAITW::DISABLED => false,
            ASYNCWAITW::ENABLED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _ASYNCWAITW<'a> {
    w: &'a mut W,
}
impl<'a> _ASYNCWAITW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ASYNCWAITW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Wait signal not used in asynchronous mode"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(ASYNCWAITW::DISABLED)
    }
    #[doc = "Wait signal used even in asynchronous mode"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(ASYNCWAITW::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 15);
        self.w.bits |= ((value as u32) & 0x01) << 15;
        self.w
    }
}
#[doc = "Possible values of the field `EXTMOD`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EXTMODR {
    #[doc = "Values inside the FMC_BWTR are not taken into account"]
    DISABLED,
    #[doc = "Values inside the FMC_BWTR are taken into account"]
    ENABLED,
}
impl EXTMODR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            EXTMODR::DISABLED => false,
            EXTMODR::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> EXTMODR {
        match value {
            false => EXTMODR::DISABLED,
            true => EXTMODR::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == EXTMODR::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == EXTMODR::ENABLED
    }
}
#[doc = "Values that can be written to the field `EXTMOD`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EXTMODW {
    #[doc = "Values inside the FMC_BWTR are not taken into account"]
    DISABLED,
    #[doc = "Values inside the FMC_BWTR are taken into account"]
    ENABLED,
}
impl EXTMODW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            EXTMODW::DISABLED => false,
            EXTMODW::ENABLED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _EXTMODW<'a> {
    w: &'a mut W,
}
impl<'a> _EXTMODW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EXTMODW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Values inside the FMC_BWTR are not taken into account"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(EXTMODW::DISABLED)
    }
    #[doc = "Values inside the FMC_BWTR are taken into account"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(EXTMODW::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 14);
        self.w.bits |= ((value as u32) & 0x01) << 14;
        self.w
    }
}
#[doc = "Possible values of the field `WAITEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAITENR {
    #[doc = "Values inside the FMC_BWTR are taken into account"]
    DISABLED,
    #[doc = "NWAIT signal enabled"]
    ENABLED,
}
impl WAITENR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            WAITENR::DISABLED => false,
            WAITENR::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> WAITENR {
        match value {
            false => WAITENR::DISABLED,
            true => WAITENR::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == WAITENR::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == WAITENR::ENABLED
    }
}
#[doc = "Values that can be written to the field `WAITEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAITENW {
    #[doc = "Values inside the FMC_BWTR are taken into account"]
    DISABLED,
    #[doc = "NWAIT signal enabled"]
    ENABLED,
}
impl WAITENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            WAITENW::DISABLED => false,
            WAITENW::ENABLED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _WAITENW<'a> {
    w: &'a mut W,
}
impl<'a> _WAITENW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAITENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Values inside the FMC_BWTR are taken into account"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(WAITENW::DISABLED)
    }
    #[doc = "NWAIT signal enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(WAITENW::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 13);
        self.w.bits |= ((value as u32) & 0x01) << 13;
        self.w
    }
}
#[doc = "Possible values of the field `WREN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WRENR {
    #[doc = "Write operations disabled for the bank by the FMC"]
    DISABLED,
    #[doc = "Write operations enabled for the bank by the FMC"]
    ENABLED,
}
impl WRENR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            WRENR::DISABLED => false,
            WRENR::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> WRENR {
        match value {
            false => WRENR::DISABLED,
            true => WRENR::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == WRENR::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == WRENR::ENABLED
    }
}
#[doc = "Values that can be written to the field `WREN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WRENW {
    #[doc = "Write operations disabled for the bank by the FMC"]
    DISABLED,
    #[doc = "Write operations enabled for the bank by the FMC"]
    ENABLED,
}
impl WRENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            WRENW::DISABLED => false,
            WRENW::ENABLED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _WRENW<'a> {
    w: &'a mut W,
}
impl<'a> _WRENW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WRENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Write operations disabled for the bank by the FMC"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(WRENW::DISABLED)
    }
    #[doc = "Write operations enabled for the bank by the FMC"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(WRENW::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 12);
        self.w.bits |= ((value as u32) & 0x01) << 12;
        self.w
    }
}
#[doc = "Possible values of the field `WAITCFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAITCFGR {
    #[doc = "NWAIT signal is active one data cycle before wait state"]
    BEFOREWAITSTATE,
    #[doc = "NWAIT signal is active during wait state"]
    DURINGWAITSTATE,
}
impl WAITCFGR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            WAITCFGR::BEFOREWAITSTATE => false,
            WAITCFGR::DURINGWAITSTATE => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> WAITCFGR {
        match value {
            false => WAITCFGR::BEFOREWAITSTATE,
            true => WAITCFGR::DURINGWAITSTATE,
        }
    }
    #[doc = "Checks if the value of the field is `BEFOREWAITSTATE`"]
    #[inline(always)]
    pub fn is_before_wait_state(&self) -> bool {
        *self == WAITCFGR::BEFOREWAITSTATE
    }
    #[doc = "Checks if the value of the field is `DURINGWAITSTATE`"]
    #[inline(always)]
    pub fn is_during_wait_state(&self) -> bool {
        *self == WAITCFGR::DURINGWAITSTATE
    }
}
#[doc = "Values that can be written to the field `WAITCFG`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAITCFGW {
    #[doc = "NWAIT signal is active one data cycle before wait state"]
    BEFOREWAITSTATE,
    #[doc = "NWAIT signal is active during wait state"]
    DURINGWAITSTATE,
}
impl WAITCFGW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            WAITCFGW::BEFOREWAITSTATE => false,
            WAITCFGW::DURINGWAITSTATE => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _WAITCFGW<'a> {
    w: &'a mut W,
}
impl<'a> _WAITCFGW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAITCFGW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "NWAIT signal is active one data cycle before wait state"]
    #[inline(always)]
    pub fn before_wait_state(self) -> &'a mut W {
        self.variant(WAITCFGW::BEFOREWAITSTATE)
    }
    #[doc = "NWAIT signal is active during wait state"]
    #[inline(always)]
    pub fn during_wait_state(self) -> &'a mut W {
        self.variant(WAITCFGW::DURINGWAITSTATE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 11);
        self.w.bits |= ((value as u32) & 0x01) << 11;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct WRAPMODR {
    bits: bool,
}
impl WRAPMODR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _WRAPMODW<'a> {
    w: &'a mut W,
}
impl<'a> _WRAPMODW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 10);
        self.w.bits |= ((value as u32) & 0x01) << 10;
        self.w
    }
}
#[doc = "Possible values of the field `WAITPOL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAITPOLR {
    #[doc = "NWAIT active low"]
    ACTIVELOW,
    #[doc = "NWAIT active high"]
    ACTIVEHIGH,
}
impl WAITPOLR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            WAITPOLR::ACTIVELOW => false,
            WAITPOLR::ACTIVEHIGH => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> WAITPOLR {
        match value {
            false => WAITPOLR::ACTIVELOW,
            true => WAITPOLR::ACTIVEHIGH,
        }
    }
    #[doc = "Checks if the value of the field is `ACTIVELOW`"]
    #[inline(always)]
    pub fn is_active_low(&self) -> bool {
        *self == WAITPOLR::ACTIVELOW
    }
    #[doc = "Checks if the value of the field is `ACTIVEHIGH`"]
    #[inline(always)]
    pub fn is_active_high(&self) -> bool {
        *self == WAITPOLR::ACTIVEHIGH
    }
}
#[doc = "Values that can be written to the field `WAITPOL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAITPOLW {
    #[doc = "NWAIT active low"]
    ACTIVELOW,
    #[doc = "NWAIT active high"]
    ACTIVEHIGH,
}
impl WAITPOLW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            WAITPOLW::ACTIVELOW => false,
            WAITPOLW::ACTIVEHIGH => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _WAITPOLW<'a> {
    w: &'a mut W,
}
impl<'a> _WAITPOLW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAITPOLW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "NWAIT active low"]
    #[inline(always)]
    pub fn active_low(self) -> &'a mut W {
        self.variant(WAITPOLW::ACTIVELOW)
    }
    #[doc = "NWAIT active high"]
    #[inline(always)]
    pub fn active_high(self) -> &'a mut W {
        self.variant(WAITPOLW::ACTIVEHIGH)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 9);
        self.w.bits |= ((value as u32) & 0x01) << 9;
        self.w
    }
}
#[doc = "Possible values of the field `BURSTEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BURSTENR {
    #[doc = "Burst mode disabled"]
    DISABLED,
    #[doc = "Burst mode enabled"]
    ENABLED,
}
impl BURSTENR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            BURSTENR::DISABLED => false,
            BURSTENR::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> BURSTENR {
        match value {
            false => BURSTENR::DISABLED,
            true => BURSTENR::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == BURSTENR::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == BURSTENR::ENABLED
    }
}
#[doc = "Values that can be written to the field `BURSTEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BURSTENW {
    #[doc = "Burst mode disabled"]
    DISABLED,
    #[doc = "Burst mode enabled"]
    ENABLED,
}
impl BURSTENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            BURSTENW::DISABLED => false,
            BURSTENW::ENABLED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _BURSTENW<'a> {
    w: &'a mut W,
}
impl<'a> _BURSTENW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BURSTENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Burst mode disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(BURSTENW::DISABLED)
    }
    #[doc = "Burst mode enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(BURSTENW::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 8);
        self.w.bits |= ((value as u32) & 0x01) << 8;
        self.w
    }
}
#[doc = "Possible values of the field `FACCEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FACCENR {
    #[doc = "Corresponding NOR Flash memory access is disabled"]
    DISABLED,
    #[doc = "Corresponding NOR Flash memory access is enabled"]
    ENABLED,
}
impl FACCENR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            FACCENR::DISABLED => false,
            FACCENR::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> FACCENR {
        match value {
            false => FACCENR::DISABLED,
            true => FACCENR::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == FACCENR::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == FACCENR::ENABLED
    }
}
#[doc = "Values that can be written to the field `FACCEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FACCENW {
    #[doc = "Corresponding NOR Flash memory access is disabled"]
    DISABLED,
    #[doc = "Corresponding NOR Flash memory access is enabled"]
    ENABLED,
}
impl FACCENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            FACCENW::DISABLED => false,
            FACCENW::ENABLED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _FACCENW<'a> {
    w: &'a mut W,
}
impl<'a> _FACCENW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FACCENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Corresponding NOR Flash memory access is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(FACCENW::DISABLED)
    }
    #[doc = "Corresponding NOR Flash memory access is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(FACCENW::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 6);
        self.w.bits |= ((value as u32) & 0x01) << 6;
        self.w
    }
}
#[doc = "Possible values of the field `MWID`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MWIDR {
    #[doc = "Memory data bus width 8 bits"]
    BITS8,
    #[doc = "Memory data bus width 16 bits"]
    BITS16,
    #[doc = "Memory data bus width 32 bits"]
    BITS32,
    #[doc = r"Reserved"]
    _Reserved(u8),
}
impl MWIDR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        match *self {
            MWIDR::BITS8 => 0,
            MWIDR::BITS16 => 0x01,
            MWIDR::BITS32 => 0x02,
            MWIDR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: u8) -> MWIDR {
        match value {
            0 => MWIDR::BITS8,
            1 => MWIDR::BITS16,
            2 => MWIDR::BITS32,
            i => MWIDR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `BITS8`"]
    #[inline(always)]
    pub fn is_bits8(&self) -> bool {
        *self == MWIDR::BITS8
    }
    #[doc = "Checks if the value of the field is `BITS16`"]
    #[inline(always)]
    pub fn is_bits16(&self) -> bool {
        *self == MWIDR::BITS16
    }
    #[doc = "Checks if the value of the field is `BITS32`"]
    #[inline(always)]
    pub fn is_bits32(&self) -> bool {
        *self == MWIDR::BITS32
    }
}
#[doc = "Values that can be written to the field `MWID`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MWIDW {
    #[doc = "Memory data bus width 8 bits"]
    BITS8,
    #[doc = "Memory data bus width 16 bits"]
    BITS16,
    #[doc = "Memory data bus width 32 bits"]
    BITS32,
}
impl MWIDW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> u8 {
        match *self {
            MWIDW::BITS8 => 0,
            MWIDW::BITS16 => 1,
            MWIDW::BITS32 => 2,
        }
    }
}
#[doc = r"Proxy"]
pub struct _MWIDW<'a> {
    w: &'a mut W,
}
impl<'a> _MWIDW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MWIDW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "Memory data bus width 8 bits"]
    #[inline(always)]
    pub fn bits8(self) -> &'a mut W {
        self.variant(MWIDW::BITS8)
    }
    #[doc = "Memory data bus width 16 bits"]
    #[inline(always)]
    pub fn bits16(self) -> &'a mut W {
        self.variant(MWIDW::BITS16)
    }
    #[doc = "Memory data bus width 32 bits"]
    #[inline(always)]
    pub fn bits32(self) -> &'a mut W {
        self.variant(MWIDW::BITS32)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x03 << 4);
        self.w.bits |= ((value as u32) & 0x03) << 4;
        self.w
    }
}
#[doc = "Possible values of the field `MTYP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MTYPR {
    #[doc = "SRAM memory type"]
    SRAM,
    #[doc = "PSRAM (CRAM) memory type"]
    PSRAM,
    #[doc = "NOR Flash/OneNAND Flash"]
    FLASH,
    #[doc = r"Reserved"]
    _Reserved(u8),
}
impl MTYPR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        match *self {
            MTYPR::SRAM => 0,
            MTYPR::PSRAM => 0x01,
            MTYPR::FLASH => 0x02,
            MTYPR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: u8) -> MTYPR {
        match value {
            0 => MTYPR::SRAM,
            1 => MTYPR::PSRAM,
            2 => MTYPR::FLASH,
            i => MTYPR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `SRAM`"]
    #[inline(always)]
    pub fn is_sram(&self) -> bool {
        *self == MTYPR::SRAM
    }
    #[doc = "Checks if the value of the field is `PSRAM`"]
    #[inline(always)]
    pub fn is_psram(&self) -> bool {
        *self == MTYPR::PSRAM
    }
    #[doc = "Checks if the value of the field is `FLASH`"]
    #[inline(always)]
    pub fn is_flash(&self) -> bool {
        *self == MTYPR::FLASH
    }
}
#[doc = "Values that can be written to the field `MTYP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MTYPW {
    #[doc = "SRAM memory type"]
    SRAM,
    #[doc = "PSRAM (CRAM) memory type"]
    PSRAM,
    #[doc = "NOR Flash/OneNAND Flash"]
    FLASH,
}
impl MTYPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> u8 {
        match *self {
            MTYPW::SRAM => 0,
            MTYPW::PSRAM => 1,
            MTYPW::FLASH => 2,
        }
    }
}
#[doc = r"Proxy"]
pub struct _MTYPW<'a> {
    w: &'a mut W,
}
impl<'a> _MTYPW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MTYPW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "SRAM memory type"]
    #[inline(always)]
    pub fn sram(self) -> &'a mut W {
        self.variant(MTYPW::SRAM)
    }
    #[doc = "PSRAM (CRAM) memory type"]
    #[inline(always)]
    pub fn psram(self) -> &'a mut W {
        self.variant(MTYPW::PSRAM)
    }
    #[doc = "NOR Flash/OneNAND Flash"]
    #[inline(always)]
    pub fn flash(self) -> &'a mut W {
        self.variant(MTYPW::FLASH)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x03 << 2);
        self.w.bits |= ((value as u32) & 0x03) << 2;
        self.w
    }
}
#[doc = "Possible values of the field `MUXEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MUXENR {
    #[doc = "Address/Data non-multiplexed"]
    DISABLED,
    #[doc = "Address/Data multiplexed on databus"]
    ENABLED,
}
impl MUXENR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            MUXENR::DISABLED => false,
            MUXENR::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> MUXENR {
        match value {
            false => MUXENR::DISABLED,
            true => MUXENR::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == MUXENR::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == MUXENR::ENABLED
    }
}
#[doc = "Values that can be written to the field `MUXEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MUXENW {
    #[doc = "Address/Data non-multiplexed"]
    DISABLED,
    #[doc = "Address/Data multiplexed on databus"]
    ENABLED,
}
impl MUXENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            MUXENW::DISABLED => false,
            MUXENW::ENABLED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _MUXENW<'a> {
    w: &'a mut W,
}
impl<'a> _MUXENW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MUXENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Address/Data non-multiplexed"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(MUXENW::DISABLED)
    }
    #[doc = "Address/Data multiplexed on databus"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(MUXENW::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 1);
        self.w.bits |= ((value as u32) & 0x01) << 1;
        self.w
    }
}
#[doc = "Possible values of the field `MBKEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MBKENR {
    #[doc = "Corresponding memory bank is disabled"]
    DISABLED,
    #[doc = "Corresponding memory bank is enabled"]
    ENABLED,
}
impl MBKENR {
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        match *self {
            MBKENR::DISABLED => false,
            MBKENR::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: bool) -> MBKENR {
        match value {
            false => MBKENR::DISABLED,
            true => MBKENR::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == MBKENR::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == MBKENR::ENABLED
    }
}
#[doc = "Values that can be written to the field `MBKEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MBKENW {
    #[doc = "Corresponding memory bank is disabled"]
    DISABLED,
    #[doc = "Corresponding memory bank is enabled"]
    ENABLED,
}
impl MBKENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> bool {
        match *self {
            MBKENW::DISABLED => false,
            MBKENW::ENABLED => true,
        }
    }
}
#[doc = r"Proxy"]
pub struct _MBKENW<'a> {
    w: &'a mut W,
}
impl<'a> _MBKENW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MBKENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Corresponding memory bank is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(MBKENW::DISABLED)
    }
    #[doc = "Corresponding memory bank is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(MBKENW::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 0);
        self.w.bits |= ((value as u32) & 0x01) << 0;
        self.w
    }
}
#[doc = "Possible values of the field `CPSIZE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CPSIZER {
    #[doc = "No burst split when crossing page boundary"]
    NOBURSTSPLIT,
    #[doc = "128 bytes CRAM page size"]
    BYTES128,
    #[doc = "256 bytes CRAM page size"]
    BYTES256,
    #[doc = "512 bytes CRAM page size"]
    BYTES512,
    #[doc = "1024 bytes CRAM page size"]
    BYTES1024,
    #[doc = r"Reserved"]
    _Reserved(u8),
}
impl CPSIZER {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        match *self {
            CPSIZER::NOBURSTSPLIT => 0,
            CPSIZER::BYTES128 => 0x01,
            CPSIZER::BYTES256 => 0x02,
            CPSIZER::BYTES512 => 0x03,
            CPSIZER::BYTES1024 => 0x04,
            CPSIZER::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _from(value: u8) -> CPSIZER {
        match value {
            0 => CPSIZER::NOBURSTSPLIT,
            1 => CPSIZER::BYTES128,
            2 => CPSIZER::BYTES256,
            3 => CPSIZER::BYTES512,
            4 => CPSIZER::BYTES1024,
            i => CPSIZER::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `NOBURSTSPLIT`"]
    #[inline(always)]
    pub fn is_no_burst_split(&self) -> bool {
        *self == CPSIZER::NOBURSTSPLIT
    }
    #[doc = "Checks if the value of the field is `BYTES128`"]
    #[inline(always)]
    pub fn is_bytes128(&self) -> bool {
        *self == CPSIZER::BYTES128
    }
    #[doc = "Checks if the value of the field is `BYTES256`"]
    #[inline(always)]
    pub fn is_bytes256(&self) -> bool {
        *self == CPSIZER::BYTES256
    }
    #[doc = "Checks if the value of the field is `BYTES512`"]
    #[inline(always)]
    pub fn is_bytes512(&self) -> bool {
        *self == CPSIZER::BYTES512
    }
    #[doc = "Checks if the value of the field is `BYTES1024`"]
    #[inline(always)]
    pub fn is_bytes1024(&self) -> bool {
        *self == CPSIZER::BYTES1024
    }
}
#[doc = "Values that can be written to the field `CPSIZE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CPSIZEW {
    #[doc = "No burst split when crossing page boundary"]
    NOBURSTSPLIT,
    #[doc = "128 bytes CRAM page size"]
    BYTES128,
    #[doc = "256 bytes CRAM page size"]
    BYTES256,
    #[doc = "512 bytes CRAM page size"]
    BYTES512,
    #[doc = "1024 bytes CRAM page size"]
    BYTES1024,
}
impl CPSIZEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline(always)]
    pub fn _bits(&self) -> u8 {
        match *self {
            CPSIZEW::NOBURSTSPLIT => 0,
            CPSIZEW::BYTES128 => 1,
            CPSIZEW::BYTES256 => 2,
            CPSIZEW::BYTES512 => 3,
            CPSIZEW::BYTES1024 => 4,
        }
    }
}
#[doc = r"Proxy"]
pub struct _CPSIZEW<'a> {
    w: &'a mut W,
}
impl<'a> _CPSIZEW<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CPSIZEW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "No burst split when crossing page boundary"]
    #[inline(always)]
    pub fn no_burst_split(self) -> &'a mut W {
        self.variant(CPSIZEW::NOBURSTSPLIT)
    }
    #[doc = "128 bytes CRAM page size"]
    #[inline(always)]
    pub fn bytes128(self) -> &'a mut W {
        self.variant(CPSIZEW::BYTES128)
    }
    #[doc = "256 bytes CRAM page size"]
    #[inline(always)]
    pub fn bytes256(self) -> &'a mut W {
        self.variant(CPSIZEW::BYTES256)
    }
    #[doc = "512 bytes CRAM page size"]
    #[inline(always)]
    pub fn bytes512(self) -> &'a mut W {
        self.variant(CPSIZEW::BYTES512)
    }
    #[doc = "1024 bytes CRAM page size"]
    #[inline(always)]
    pub fn bytes1024(self) -> &'a mut W {
        self.variant(CPSIZEW::BYTES1024)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x07 << 16);
        self.w.bits |= ((value as u32) & 0x07) << 16;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 19 - CBURSTRW"]
    #[inline(always)]
    pub fn cburstrw(&self) -> CBURSTRWR {
        CBURSTRWR::_from(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bit 15 - ASYNCWAIT"]
    #[inline(always)]
    pub fn asyncwait(&self) -> ASYNCWAITR {
        ASYNCWAITR::_from(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 14 - EXTMOD"]
    #[inline(always)]
    pub fn extmod(&self) -> EXTMODR {
        EXTMODR::_from(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 13 - WAITEN"]
    #[inline(always)]
    pub fn waiten(&self) -> WAITENR {
        WAITENR::_from(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 12 - WREN"]
    #[inline(always)]
    pub fn wren(&self) -> WRENR {
        WRENR::_from(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 11 - WAITCFG"]
    #[inline(always)]
    pub fn waitcfg(&self) -> WAITCFGR {
        WAITCFGR::_from(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 10 - WRAPMOD"]
    #[inline(always)]
    pub fn wrapmod(&self) -> WRAPMODR {
        let bits = ((self.bits >> 10) & 0x01) != 0;
        WRAPMODR { bits }
    }
    #[doc = "Bit 9 - WAITPOL"]
    #[inline(always)]
    pub fn waitpol(&self) -> WAITPOLR {
        WAITPOLR::_from(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 8 - BURSTEN"]
    #[inline(always)]
    pub fn bursten(&self) -> BURSTENR {
        BURSTENR::_from(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 6 - FACCEN"]
    #[inline(always)]
    pub fn faccen(&self) -> FACCENR {
        FACCENR::_from(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bits 4:5 - MWID"]
    #[inline(always)]
    pub fn mwid(&self) -> MWIDR {
        MWIDR::_from(((self.bits >> 4) & 0x03) as u8)
    }
    #[doc = "Bits 2:3 - MTYP"]
    #[inline(always)]
    pub fn mtyp(&self) -> MTYPR {
        MTYPR::_from(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bit 1 - MUXEN"]
    #[inline(always)]
    pub fn muxen(&self) -> MUXENR {
        MUXENR::_from(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 0 - MBKEN"]
    #[inline(always)]
    pub fn mbken(&self) -> MBKENR {
        MBKENR::_from(((self.bits >> 0) & 0x01) != 0)
    }
    #[doc = "Bits 16:18 - CRAM page size"]
    #[inline(always)]
    pub fn cpsize(&self) -> CPSIZER {
        CPSIZER::_from(((self.bits >> 16) & 0x07) as u8)
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 19 - CBURSTRW"]
    #[inline(always)]
    pub fn cburstrw(&mut self) -> _CBURSTRWW {
        _CBURSTRWW { w: self }
    }
    #[doc = "Bit 15 - ASYNCWAIT"]
    #[inline(always)]
    pub fn asyncwait(&mut self) -> _ASYNCWAITW {
        _ASYNCWAITW { w: self }
    }
    #[doc = "Bit 14 - EXTMOD"]
    #[inline(always)]
    pub fn extmod(&mut self) -> _EXTMODW {
        _EXTMODW { w: self }
    }
    #[doc = "Bit 13 - WAITEN"]
    #[inline(always)]
    pub fn waiten(&mut self) -> _WAITENW {
        _WAITENW { w: self }
    }
    #[doc = "Bit 12 - WREN"]
    #[inline(always)]
    pub fn wren(&mut self) -> _WRENW {
        _WRENW { w: self }
    }
    #[doc = "Bit 11 - WAITCFG"]
    #[inline(always)]
    pub fn waitcfg(&mut self) -> _WAITCFGW {
        _WAITCFGW { w: self }
    }
    #[doc = "Bit 10 - WRAPMOD"]
    #[inline(always)]
    pub fn wrapmod(&mut self) -> _WRAPMODW {
        _WRAPMODW { w: self }
    }
    #[doc = "Bit 9 - WAITPOL"]
    #[inline(always)]
    pub fn waitpol(&mut self) -> _WAITPOLW {
        _WAITPOLW { w: self }
    }
    #[doc = "Bit 8 - BURSTEN"]
    #[inline(always)]
    pub fn bursten(&mut self) -> _BURSTENW {
        _BURSTENW { w: self }
    }
    #[doc = "Bit 6 - FACCEN"]
    #[inline(always)]
    pub fn faccen(&mut self) -> _FACCENW {
        _FACCENW { w: self }
    }
    #[doc = "Bits 4:5 - MWID"]
    #[inline(always)]
    pub fn mwid(&mut self) -> _MWIDW {
        _MWIDW { w: self }
    }
    #[doc = "Bits 2:3 - MTYP"]
    #[inline(always)]
    pub fn mtyp(&mut self) -> _MTYPW {
        _MTYPW { w: self }
    }
    #[doc = "Bit 1 - MUXEN"]
    #[inline(always)]
    pub fn muxen(&mut self) -> _MUXENW {
        _MUXENW { w: self }
    }
    #[doc = "Bit 0 - MBKEN"]
    #[inline(always)]
    pub fn mbken(&mut self) -> _MBKENW {
        _MBKENW { w: self }
    }
    #[doc = "Bits 16:18 - CRAM page size"]
    #[inline(always)]
    pub fn cpsize(&mut self) -> _CPSIZEW {
        _CPSIZEW { w: self }
    }
}
