#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::CSR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0x0001_0101
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct OPA3CALOUTR {
    bits: bool,
}
impl OPA3CALOUTR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA3CALOUTW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA3CALOUTW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 31);
        self.w.bits |= ((value as u32) & 0x01) << 31;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA2CALOUTR {
    bits: bool,
}
impl OPA2CALOUTR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA2CALOUTW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA2CALOUTW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 30);
        self.w.bits |= ((value as u32) & 0x01) << 30;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA1CALOUTR {
    bits: bool,
}
impl OPA1CALOUTR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA1CALOUTW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA1CALOUTW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 29);
        self.w.bits |= ((value as u32) & 0x01) << 29;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct AOP_RANGER {
    bits: bool,
}
impl AOP_RANGER {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _AOP_RANGEW<'a> {
    w: &'a mut W,
}
impl<'a> _AOP_RANGEW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 28);
        self.w.bits |= ((value as u32) & 0x01) << 28;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S7SEL2R {
    bits: bool,
}
impl S7SEL2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S7SEL2W<'a> {
    w: &'a mut W,
}
impl<'a> _S7SEL2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 27);
        self.w.bits |= ((value as u32) & 0x01) << 27;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct ANAWSEL3R {
    bits: bool,
}
impl ANAWSEL3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _ANAWSEL3W<'a> {
    w: &'a mut W,
}
impl<'a> _ANAWSEL3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 26);
        self.w.bits |= ((value as u32) & 0x01) << 26;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct ANAWSEL2R {
    bits: bool,
}
impl ANAWSEL2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _ANAWSEL2W<'a> {
    w: &'a mut W,
}
impl<'a> _ANAWSEL2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 25);
        self.w.bits |= ((value as u32) & 0x01) << 25;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct ANAWSEL1R {
    bits: bool,
}
impl ANAWSEL1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _ANAWSEL1W<'a> {
    w: &'a mut W,
}
impl<'a> _ANAWSEL1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 24);
        self.w.bits |= ((value as u32) & 0x01) << 24;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA3LPMR {
    bits: bool,
}
impl OPA3LPMR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA3LPMW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA3LPMW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 23);
        self.w.bits |= ((value as u32) & 0x01) << 23;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA3CAL_HR {
    bits: bool,
}
impl OPA3CAL_HR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA3CAL_HW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA3CAL_HW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 22);
        self.w.bits |= ((value as u32) & 0x01) << 22;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA3CAL_LR {
    bits: bool,
}
impl OPA3CAL_LR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA3CAL_LW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA3CAL_LW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 21);
        self.w.bits |= ((value as u32) & 0x01) << 21;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S6SEL3R {
    bits: bool,
}
impl S6SEL3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S6SEL3W<'a> {
    w: &'a mut W,
}
impl<'a> _S6SEL3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 20);
        self.w.bits |= ((value as u32) & 0x01) << 20;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S5SEL3R {
    bits: bool,
}
impl S5SEL3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S5SEL3W<'a> {
    w: &'a mut W,
}
impl<'a> _S5SEL3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 19);
        self.w.bits |= ((value as u32) & 0x01) << 19;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S4SEL3R {
    bits: bool,
}
impl S4SEL3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S4SEL3W<'a> {
    w: &'a mut W,
}
impl<'a> _S4SEL3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 18);
        self.w.bits |= ((value as u32) & 0x01) << 18;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S3SEL3R {
    bits: bool,
}
impl S3SEL3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S3SEL3W<'a> {
    w: &'a mut W,
}
impl<'a> _S3SEL3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 17);
        self.w.bits |= ((value as u32) & 0x01) << 17;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA3PDR {
    bits: bool,
}
impl OPA3PDR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA3PDW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA3PDW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 16);
        self.w.bits |= ((value as u32) & 0x01) << 16;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA2LPMR {
    bits: bool,
}
impl OPA2LPMR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA2LPMW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA2LPMW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 15);
        self.w.bits |= ((value as u32) & 0x01) << 15;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA2CAL_HR {
    bits: bool,
}
impl OPA2CAL_HR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA2CAL_HW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA2CAL_HW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 14);
        self.w.bits |= ((value as u32) & 0x01) << 14;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA2CAL_LR {
    bits: bool,
}
impl OPA2CAL_LR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA2CAL_LW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA2CAL_LW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 13);
        self.w.bits |= ((value as u32) & 0x01) << 13;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S6SEL2R {
    bits: bool,
}
impl S6SEL2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S6SEL2W<'a> {
    w: &'a mut W,
}
impl<'a> _S6SEL2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 12);
        self.w.bits |= ((value as u32) & 0x01) << 12;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S5SEL2R {
    bits: bool,
}
impl S5SEL2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S5SEL2W<'a> {
    w: &'a mut W,
}
impl<'a> _S5SEL2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 11);
        self.w.bits |= ((value as u32) & 0x01) << 11;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S4SEL2R {
    bits: bool,
}
impl S4SEL2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S4SEL2W<'a> {
    w: &'a mut W,
}
impl<'a> _S4SEL2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 10);
        self.w.bits |= ((value as u32) & 0x01) << 10;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S3SEL2R {
    bits: bool,
}
impl S3SEL2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S3SEL2W<'a> {
    w: &'a mut W,
}
impl<'a> _S3SEL2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 9);
        self.w.bits |= ((value as u32) & 0x01) << 9;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA2PDR {
    bits: bool,
}
impl OPA2PDR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA2PDW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA2PDW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 8);
        self.w.bits |= ((value as u32) & 0x01) << 8;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA1LPMR {
    bits: bool,
}
impl OPA1LPMR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA1LPMW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA1LPMW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 7);
        self.w.bits |= ((value as u32) & 0x01) << 7;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA1CAL_HR {
    bits: bool,
}
impl OPA1CAL_HR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA1CAL_HW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA1CAL_HW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 6);
        self.w.bits |= ((value as u32) & 0x01) << 6;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA1CAL_LR {
    bits: bool,
}
impl OPA1CAL_LR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA1CAL_LW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA1CAL_LW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 5);
        self.w.bits |= ((value as u32) & 0x01) << 5;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S6SEL1R {
    bits: bool,
}
impl S6SEL1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S6SEL1W<'a> {
    w: &'a mut W,
}
impl<'a> _S6SEL1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 4);
        self.w.bits |= ((value as u32) & 0x01) << 4;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S5SEL1R {
    bits: bool,
}
impl S5SEL1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S5SEL1W<'a> {
    w: &'a mut W,
}
impl<'a> _S5SEL1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 3);
        self.w.bits |= ((value as u32) & 0x01) << 3;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S4SEL1R {
    bits: bool,
}
impl S4SEL1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S4SEL1W<'a> {
    w: &'a mut W,
}
impl<'a> _S4SEL1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 2);
        self.w.bits |= ((value as u32) & 0x01) << 2;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct S3SEL1R {
    bits: bool,
}
impl S3SEL1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _S3SEL1W<'a> {
    w: &'a mut W,
}
impl<'a> _S3SEL1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 1);
        self.w.bits |= ((value as u32) & 0x01) << 1;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct OPA1PDR {
    bits: bool,
}
impl OPA1PDR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _OPA1PDW<'a> {
    w: &'a mut W,
}
impl<'a> _OPA1PDW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 0);
        self.w.bits |= ((value as u32) & 0x01) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 31 - OPAMP3 calibration output"]
    #[inline(always)]
    pub fn opa3calout(&self) -> OPA3CALOUTR {
        let bits = ((self.bits >> 31) & 0x01) != 0;
        OPA3CALOUTR { bits }
    }
    #[doc = "Bit 30 - OPAMP2 calibration output"]
    #[inline(always)]
    pub fn opa2calout(&self) -> OPA2CALOUTR {
        let bits = ((self.bits >> 30) & 0x01) != 0;
        OPA2CALOUTR { bits }
    }
    #[doc = "Bit 29 - OPAMP1 calibration output"]
    #[inline(always)]
    pub fn opa1calout(&self) -> OPA1CALOUTR {
        let bits = ((self.bits >> 29) & 0x01) != 0;
        OPA1CALOUTR { bits }
    }
    #[doc = "Bit 28 - Power range selection"]
    #[inline(always)]
    pub fn aop_range(&self) -> AOP_RANGER {
        let bits = ((self.bits >> 28) & 0x01) != 0;
        AOP_RANGER { bits }
    }
    #[doc = "Bit 27 - Switch 7 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s7sel2(&self) -> S7SEL2R {
        let bits = ((self.bits >> 27) & 0x01) != 0;
        S7SEL2R { bits }
    }
    #[doc = "Bit 26 - Switch SanA enable for OPAMP3"]
    #[inline(always)]
    pub fn anawsel3(&self) -> ANAWSEL3R {
        let bits = ((self.bits >> 26) & 0x01) != 0;
        ANAWSEL3R { bits }
    }
    #[doc = "Bit 25 - Switch SanA enable for OPAMP2"]
    #[inline(always)]
    pub fn anawsel2(&self) -> ANAWSEL2R {
        let bits = ((self.bits >> 25) & 0x01) != 0;
        ANAWSEL2R { bits }
    }
    #[doc = "Bit 24 - Switch SanA enable for OPAMP1"]
    #[inline(always)]
    pub fn anawsel1(&self) -> ANAWSEL1R {
        let bits = ((self.bits >> 24) & 0x01) != 0;
        ANAWSEL1R { bits }
    }
    #[doc = "Bit 23 - OPAMP3 low power mode"]
    #[inline(always)]
    pub fn opa3lpm(&self) -> OPA3LPMR {
        let bits = ((self.bits >> 23) & 0x01) != 0;
        OPA3LPMR { bits }
    }
    #[doc = "Bit 22 - OPAMP3 offset calibration for N differential pair"]
    #[inline(always)]
    pub fn opa3cal_h(&self) -> OPA3CAL_HR {
        let bits = ((self.bits >> 22) & 0x01) != 0;
        OPA3CAL_HR { bits }
    }
    #[doc = "Bit 21 - OPAMP3 offset Calibration for P differential pair"]
    #[inline(always)]
    pub fn opa3cal_l(&self) -> OPA3CAL_LR {
        let bits = ((self.bits >> 21) & 0x01) != 0;
        OPA3CAL_LR { bits }
    }
    #[doc = "Bit 20 - Switch 6 for OPAMP3 enable"]
    #[inline(always)]
    pub fn s6sel3(&self) -> S6SEL3R {
        let bits = ((self.bits >> 20) & 0x01) != 0;
        S6SEL3R { bits }
    }
    #[doc = "Bit 19 - Switch 5 for OPAMP3 enable"]
    #[inline(always)]
    pub fn s5sel3(&self) -> S5SEL3R {
        let bits = ((self.bits >> 19) & 0x01) != 0;
        S5SEL3R { bits }
    }
    #[doc = "Bit 18 - Switch 4 for OPAMP3 enable"]
    #[inline(always)]
    pub fn s4sel3(&self) -> S4SEL3R {
        let bits = ((self.bits >> 18) & 0x01) != 0;
        S4SEL3R { bits }
    }
    #[doc = "Bit 17 - Switch 3 for OPAMP3 Enable"]
    #[inline(always)]
    pub fn s3sel3(&self) -> S3SEL3R {
        let bits = ((self.bits >> 17) & 0x01) != 0;
        S3SEL3R { bits }
    }
    #[doc = "Bit 16 - OPAMP3 power down"]
    #[inline(always)]
    pub fn opa3pd(&self) -> OPA3PDR {
        let bits = ((self.bits >> 16) & 0x01) != 0;
        OPA3PDR { bits }
    }
    #[doc = "Bit 15 - OPAMP2 low power mode"]
    #[inline(always)]
    pub fn opa2lpm(&self) -> OPA2LPMR {
        let bits = ((self.bits >> 15) & 0x01) != 0;
        OPA2LPMR { bits }
    }
    #[doc = "Bit 14 - OPAMP2 offset calibration for N differential pair"]
    #[inline(always)]
    pub fn opa2cal_h(&self) -> OPA2CAL_HR {
        let bits = ((self.bits >> 14) & 0x01) != 0;
        OPA2CAL_HR { bits }
    }
    #[doc = "Bit 13 - OPAMP2 offset Calibration for P differential pair"]
    #[inline(always)]
    pub fn opa2cal_l(&self) -> OPA2CAL_LR {
        let bits = ((self.bits >> 13) & 0x01) != 0;
        OPA2CAL_LR { bits }
    }
    #[doc = "Bit 12 - Switch 6 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s6sel2(&self) -> S6SEL2R {
        let bits = ((self.bits >> 12) & 0x01) != 0;
        S6SEL2R { bits }
    }
    #[doc = "Bit 11 - Switch 5 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s5sel2(&self) -> S5SEL2R {
        let bits = ((self.bits >> 11) & 0x01) != 0;
        S5SEL2R { bits }
    }
    #[doc = "Bit 10 - Switch 4 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s4sel2(&self) -> S4SEL2R {
        let bits = ((self.bits >> 10) & 0x01) != 0;
        S4SEL2R { bits }
    }
    #[doc = "Bit 9 - Switch 3 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s3sel2(&self) -> S3SEL2R {
        let bits = ((self.bits >> 9) & 0x01) != 0;
        S3SEL2R { bits }
    }
    #[doc = "Bit 8 - OPAMP2 power down"]
    #[inline(always)]
    pub fn opa2pd(&self) -> OPA2PDR {
        let bits = ((self.bits >> 8) & 0x01) != 0;
        OPA2PDR { bits }
    }
    #[doc = "Bit 7 - OPAMP1 low power mode"]
    #[inline(always)]
    pub fn opa1lpm(&self) -> OPA1LPMR {
        let bits = ((self.bits >> 7) & 0x01) != 0;
        OPA1LPMR { bits }
    }
    #[doc = "Bit 6 - OPAMP1 offset calibration for N differential pair"]
    #[inline(always)]
    pub fn opa1cal_h(&self) -> OPA1CAL_HR {
        let bits = ((self.bits >> 6) & 0x01) != 0;
        OPA1CAL_HR { bits }
    }
    #[doc = "Bit 5 - OPAMP1 offset calibration for P differential pair"]
    #[inline(always)]
    pub fn opa1cal_l(&self) -> OPA1CAL_LR {
        let bits = ((self.bits >> 5) & 0x01) != 0;
        OPA1CAL_LR { bits }
    }
    #[doc = "Bit 4 - Switch 6 for OPAMP1 enable"]
    #[inline(always)]
    pub fn s6sel1(&self) -> S6SEL1R {
        let bits = ((self.bits >> 4) & 0x01) != 0;
        S6SEL1R { bits }
    }
    #[doc = "Bit 3 - Switch 5 for OPAMP1 enable"]
    #[inline(always)]
    pub fn s5sel1(&self) -> S5SEL1R {
        let bits = ((self.bits >> 3) & 0x01) != 0;
        S5SEL1R { bits }
    }
    #[doc = "Bit 2 - Switch 4 for OPAMP1 enable"]
    #[inline(always)]
    pub fn s4sel1(&self) -> S4SEL1R {
        let bits = ((self.bits >> 2) & 0x01) != 0;
        S4SEL1R { bits }
    }
    #[doc = "Bit 1 - Switch 3 for OPAMP1 enable"]
    #[inline(always)]
    pub fn s3sel1(&self) -> S3SEL1R {
        let bits = ((self.bits >> 1) & 0x01) != 0;
        S3SEL1R { bits }
    }
    #[doc = "Bit 0 - OPAMP1 power down"]
    #[inline(always)]
    pub fn opa1pd(&self) -> OPA1PDR {
        let bits = ((self.bits >> 0) & 0x01) != 0;
        OPA1PDR { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 31 - OPAMP3 calibration output"]
    #[inline(always)]
    pub fn opa3calout(&mut self) -> _OPA3CALOUTW {
        _OPA3CALOUTW { w: self }
    }
    #[doc = "Bit 30 - OPAMP2 calibration output"]
    #[inline(always)]
    pub fn opa2calout(&mut self) -> _OPA2CALOUTW {
        _OPA2CALOUTW { w: self }
    }
    #[doc = "Bit 29 - OPAMP1 calibration output"]
    #[inline(always)]
    pub fn opa1calout(&mut self) -> _OPA1CALOUTW {
        _OPA1CALOUTW { w: self }
    }
    #[doc = "Bit 28 - Power range selection"]
    #[inline(always)]
    pub fn aop_range(&mut self) -> _AOP_RANGEW {
        _AOP_RANGEW { w: self }
    }
    #[doc = "Bit 27 - Switch 7 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s7sel2(&mut self) -> _S7SEL2W {
        _S7SEL2W { w: self }
    }
    #[doc = "Bit 26 - Switch SanA enable for OPAMP3"]
    #[inline(always)]
    pub fn anawsel3(&mut self) -> _ANAWSEL3W {
        _ANAWSEL3W { w: self }
    }
    #[doc = "Bit 25 - Switch SanA enable for OPAMP2"]
    #[inline(always)]
    pub fn anawsel2(&mut self) -> _ANAWSEL2W {
        _ANAWSEL2W { w: self }
    }
    #[doc = "Bit 24 - Switch SanA enable for OPAMP1"]
    #[inline(always)]
    pub fn anawsel1(&mut self) -> _ANAWSEL1W {
        _ANAWSEL1W { w: self }
    }
    #[doc = "Bit 23 - OPAMP3 low power mode"]
    #[inline(always)]
    pub fn opa3lpm(&mut self) -> _OPA3LPMW {
        _OPA3LPMW { w: self }
    }
    #[doc = "Bit 22 - OPAMP3 offset calibration for N differential pair"]
    #[inline(always)]
    pub fn opa3cal_h(&mut self) -> _OPA3CAL_HW {
        _OPA3CAL_HW { w: self }
    }
    #[doc = "Bit 21 - OPAMP3 offset Calibration for P differential pair"]
    #[inline(always)]
    pub fn opa3cal_l(&mut self) -> _OPA3CAL_LW {
        _OPA3CAL_LW { w: self }
    }
    #[doc = "Bit 20 - Switch 6 for OPAMP3 enable"]
    #[inline(always)]
    pub fn s6sel3(&mut self) -> _S6SEL3W {
        _S6SEL3W { w: self }
    }
    #[doc = "Bit 19 - Switch 5 for OPAMP3 enable"]
    #[inline(always)]
    pub fn s5sel3(&mut self) -> _S5SEL3W {
        _S5SEL3W { w: self }
    }
    #[doc = "Bit 18 - Switch 4 for OPAMP3 enable"]
    #[inline(always)]
    pub fn s4sel3(&mut self) -> _S4SEL3W {
        _S4SEL3W { w: self }
    }
    #[doc = "Bit 17 - Switch 3 for OPAMP3 Enable"]
    #[inline(always)]
    pub fn s3sel3(&mut self) -> _S3SEL3W {
        _S3SEL3W { w: self }
    }
    #[doc = "Bit 16 - OPAMP3 power down"]
    #[inline(always)]
    pub fn opa3pd(&mut self) -> _OPA3PDW {
        _OPA3PDW { w: self }
    }
    #[doc = "Bit 15 - OPAMP2 low power mode"]
    #[inline(always)]
    pub fn opa2lpm(&mut self) -> _OPA2LPMW {
        _OPA2LPMW { w: self }
    }
    #[doc = "Bit 14 - OPAMP2 offset calibration for N differential pair"]
    #[inline(always)]
    pub fn opa2cal_h(&mut self) -> _OPA2CAL_HW {
        _OPA2CAL_HW { w: self }
    }
    #[doc = "Bit 13 - OPAMP2 offset Calibration for P differential pair"]
    #[inline(always)]
    pub fn opa2cal_l(&mut self) -> _OPA2CAL_LW {
        _OPA2CAL_LW { w: self }
    }
    #[doc = "Bit 12 - Switch 6 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s6sel2(&mut self) -> _S6SEL2W {
        _S6SEL2W { w: self }
    }
    #[doc = "Bit 11 - Switch 5 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s5sel2(&mut self) -> _S5SEL2W {
        _S5SEL2W { w: self }
    }
    #[doc = "Bit 10 - Switch 4 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s4sel2(&mut self) -> _S4SEL2W {
        _S4SEL2W { w: self }
    }
    #[doc = "Bit 9 - Switch 3 for OPAMP2 enable"]
    #[inline(always)]
    pub fn s3sel2(&mut self) -> _S3SEL2W {
        _S3SEL2W { w: self }
    }
    #[doc = "Bit 8 - OPAMP2 power down"]
    #[inline(always)]
    pub fn opa2pd(&mut self) -> _OPA2PDW {
        _OPA2PDW { w: self }
    }
    #[doc = "Bit 7 - OPAMP1 low power mode"]
    #[inline(always)]
    pub fn opa1lpm(&mut self) -> _OPA1LPMW {
        _OPA1LPMW { w: self }
    }
    #[doc = "Bit 6 - OPAMP1 offset calibration for N differential pair"]
    #[inline(always)]
    pub fn opa1cal_h(&mut self) -> _OPA1CAL_HW {
        _OPA1CAL_HW { w: self }
    }
    #[doc = "Bit 5 - OPAMP1 offset calibration for P differential pair"]
    #[inline(always)]
    pub fn opa1cal_l(&mut self) -> _OPA1CAL_LW {
        _OPA1CAL_LW { w: self }
    }
    #[doc = "Bit 4 - Switch 6 for OPAMP1 enable"]
    #[inline(always)]
    pub fn s6sel1(&mut self) -> _S6SEL1W {
        _S6SEL1W { w: self }
    }
    #[doc = "Bit 3 - Switch 5 for OPAMP1 enable"]
    #[inline(always)]
    pub fn s5sel1(&mut self) -> _S5SEL1W {
        _S5SEL1W { w: self }
    }
    #[doc = "Bit 2 - Switch 4 for OPAMP1 enable"]
    #[inline(always)]
    pub fn s4sel1(&mut self) -> _S4SEL1W {
        _S4SEL1W { w: self }
    }
    #[doc = "Bit 1 - Switch 3 for OPAMP1 enable"]
    #[inline(always)]
    pub fn s3sel1(&mut self) -> _S3SEL1W {
        _S3SEL1W { w: self }
    }
    #[doc = "Bit 0 - OPAMP1 power down"]
    #[inline(always)]
    pub fn opa1pd(&mut self) -> _OPA1PDW {
        _OPA1PDW { w: self }
    }
}
