#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::ASCR1 {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct SCMR {
    bits: bool,
}
impl SCMR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _SCMW<'a> {
    w: &'a mut W,
}
impl<'a> _SCMW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 31);
        self.w.bits |= ((value as u32) & 0x01) << 31;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH30GR11_4R {
    bits: bool,
}
impl CH30GR11_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH30GR11_4W<'a> {
    w: &'a mut W,
}
impl<'a> _CH30GR11_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 30);
        self.w.bits |= ((value as u32) & 0x01) << 30;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH29GR11_3R {
    bits: bool,
}
impl CH29GR11_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH29GR11_3W<'a> {
    w: &'a mut W,
}
impl<'a> _CH29GR11_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 29);
        self.w.bits |= ((value as u32) & 0x01) << 29;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH28GR11_2R {
    bits: bool,
}
impl CH28GR11_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH28GR11_2W<'a> {
    w: &'a mut W,
}
impl<'a> _CH28GR11_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 28);
        self.w.bits |= ((value as u32) & 0x01) << 28;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH27GR11_1R {
    bits: bool,
}
impl CH27GR11_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH27GR11_1W<'a> {
    w: &'a mut W,
}
impl<'a> _CH27GR11_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 27);
        self.w.bits |= ((value as u32) & 0x01) << 27;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct VCOMPR {
    bits: bool,
}
impl VCOMPR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _VCOMPW<'a> {
    w: &'a mut W,
}
impl<'a> _VCOMPW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 26);
        self.w.bits |= ((value as u32) & 0x01) << 26;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH25R {
    bits: bool,
}
impl CH25R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH25W<'a> {
    w: &'a mut W,
}
impl<'a> _CH25W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 25);
        self.w.bits |= ((value as u32) & 0x01) << 25;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH24R {
    bits: bool,
}
impl CH24R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH24W<'a> {
    w: &'a mut W,
}
impl<'a> _CH24W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 24);
        self.w.bits |= ((value as u32) & 0x01) << 24;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH23R {
    bits: bool,
}
impl CH23R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH23W<'a> {
    w: &'a mut W,
}
impl<'a> _CH23W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 23);
        self.w.bits |= ((value as u32) & 0x01) << 23;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH22R {
    bits: bool,
}
impl CH22R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH22W<'a> {
    w: &'a mut W,
}
impl<'a> _CH22W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 22);
        self.w.bits |= ((value as u32) & 0x01) << 22;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH21GR7_4R {
    bits: bool,
}
impl CH21GR7_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH21GR7_4W<'a> {
    w: &'a mut W,
}
impl<'a> _CH21GR7_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 21);
        self.w.bits |= ((value as u32) & 0x01) << 21;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH20GR7_3R {
    bits: bool,
}
impl CH20GR7_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH20GR7_3W<'a> {
    w: &'a mut W,
}
impl<'a> _CH20GR7_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 20);
        self.w.bits |= ((value as u32) & 0x01) << 20;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH19GR7_2R {
    bits: bool,
}
impl CH19GR7_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH19GR7_2W<'a> {
    w: &'a mut W,
}
impl<'a> _CH19GR7_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 19);
        self.w.bits |= ((value as u32) & 0x01) << 19;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH18GR7_1R {
    bits: bool,
}
impl CH18GR7_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH18GR7_1W<'a> {
    w: &'a mut W,
}
impl<'a> _CH18GR7_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 18);
        self.w.bits |= ((value as u32) & 0x01) << 18;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH31GR7_1R {
    bits: bool,
}
impl CH31GR7_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH31GR7_1W<'a> {
    w: &'a mut W,
}
impl<'a> _CH31GR7_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 16);
        self.w.bits |= ((value as u32) & 0x01) << 16;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH15GR9_2R {
    bits: bool,
}
impl CH15GR9_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH15GR9_2W<'a> {
    w: &'a mut W,
}
impl<'a> _CH15GR9_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 15);
        self.w.bits |= ((value as u32) & 0x01) << 15;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH14GR9_1R {
    bits: bool,
}
impl CH14GR9_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH14GR9_1W<'a> {
    w: &'a mut W,
}
impl<'a> _CH14GR9_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 14);
        self.w.bits |= ((value as u32) & 0x01) << 14;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH13GR8_4R {
    bits: bool,
}
impl CH13GR8_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH13GR8_4W<'a> {
    w: &'a mut W,
}
impl<'a> _CH13GR8_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 13);
        self.w.bits |= ((value as u32) & 0x01) << 13;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH12GR8_3R {
    bits: bool,
}
impl CH12GR8_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH12GR8_3W<'a> {
    w: &'a mut W,
}
impl<'a> _CH12GR8_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 12);
        self.w.bits |= ((value as u32) & 0x01) << 12;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH11GR8_2R {
    bits: bool,
}
impl CH11GR8_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH11GR8_2W<'a> {
    w: &'a mut W,
}
impl<'a> _CH11GR8_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 11);
        self.w.bits |= ((value as u32) & 0x01) << 11;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH10GR8_1R {
    bits: bool,
}
impl CH10GR8_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH10GR8_1W<'a> {
    w: &'a mut W,
}
impl<'a> _CH10GR8_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 10);
        self.w.bits |= ((value as u32) & 0x01) << 10;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH9GR3_2R {
    bits: bool,
}
impl CH9GR3_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH9GR3_2W<'a> {
    w: &'a mut W,
}
impl<'a> _CH9GR3_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 9);
        self.w.bits |= ((value as u32) & 0x01) << 9;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH8GR3_1R {
    bits: bool,
}
impl CH8GR3_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH8GR3_1W<'a> {
    w: &'a mut W,
}
impl<'a> _CH8GR3_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 8);
        self.w.bits |= ((value as u32) & 0x01) << 8;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH7GR2_2R {
    bits: bool,
}
impl CH7GR2_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH7GR2_2W<'a> {
    w: &'a mut W,
}
impl<'a> _CH7GR2_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 7);
        self.w.bits |= ((value as u32) & 0x01) << 7;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH6GR2_1R {
    bits: bool,
}
impl CH6GR2_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH6GR2_1W<'a> {
    w: &'a mut W,
}
impl<'a> _CH6GR2_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 6);
        self.w.bits |= ((value as u32) & 0x01) << 6;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct COMP1_SW1R {
    bits: bool,
}
impl COMP1_SW1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _COMP1_SW1W<'a> {
    w: &'a mut W,
}
impl<'a> _COMP1_SW1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 5);
        self.w.bits |= ((value as u32) & 0x01) << 5;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH31GR11_5R {
    bits: bool,
}
impl CH31GR11_5R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH31GR11_5W<'a> {
    w: &'a mut W,
}
impl<'a> _CH31GR11_5W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 4);
        self.w.bits |= ((value as u32) & 0x01) << 4;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH3GR1_4R {
    bits: bool,
}
impl CH3GR1_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH3GR1_4W<'a> {
    w: &'a mut W,
}
impl<'a> _CH3GR1_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 3);
        self.w.bits |= ((value as u32) & 0x01) << 3;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH2GR1_3R {
    bits: bool,
}
impl CH2GR1_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH2GR1_3W<'a> {
    w: &'a mut W,
}
impl<'a> _CH2GR1_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 2);
        self.w.bits |= ((value as u32) & 0x01) << 2;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH1GR1_2R {
    bits: bool,
}
impl CH1GR1_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH1GR1_2W<'a> {
    w: &'a mut W,
}
impl<'a> _CH1GR1_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 1);
        self.w.bits |= ((value as u32) & 0x01) << 1;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct CH0GR1_1R {
    bits: bool,
}
impl CH0GR1_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _CH0GR1_1W<'a> {
    w: &'a mut W,
}
impl<'a> _CH0GR1_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 0);
        self.w.bits |= ((value as u32) & 0x01) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 31 - Switch control mode"]
    #[inline(always)]
    pub fn scm(&self) -> SCMR {
        let bits = ((self.bits >> 31) & 0x01) != 0;
        SCMR { bits }
    }
    #[doc = "Bit 30 - Analog switch control"]
    #[inline(always)]
    pub fn ch30gr11_4(&self) -> CH30GR11_4R {
        let bits = ((self.bits >> 30) & 0x01) != 0;
        CH30GR11_4R { bits }
    }
    #[doc = "Bit 29 - Analog switch control"]
    #[inline(always)]
    pub fn ch29gr11_3(&self) -> CH29GR11_3R {
        let bits = ((self.bits >> 29) & 0x01) != 0;
        CH29GR11_3R { bits }
    }
    #[doc = "Bit 28 - Analog switch control"]
    #[inline(always)]
    pub fn ch28gr11_2(&self) -> CH28GR11_2R {
        let bits = ((self.bits >> 28) & 0x01) != 0;
        CH28GR11_2R { bits }
    }
    #[doc = "Bit 27 - Analog switch control"]
    #[inline(always)]
    pub fn ch27gr11_1(&self) -> CH27GR11_1R {
        let bits = ((self.bits >> 27) & 0x01) != 0;
        CH27GR11_1R { bits }
    }
    #[doc = "Bit 26 - ADC analog switch selection for internal node to comparator 1"]
    #[inline(always)]
    pub fn vcomp(&self) -> VCOMPR {
        let bits = ((self.bits >> 26) & 0x01) != 0;
        VCOMPR { bits }
    }
    #[doc = "Bit 25 - Analog I/O switch control of channel CH25"]
    #[inline(always)]
    pub fn ch25(&self) -> CH25R {
        let bits = ((self.bits >> 25) & 0x01) != 0;
        CH25R { bits }
    }
    #[doc = "Bit 24 - Analog I/O switch control of channel CH24"]
    #[inline(always)]
    pub fn ch24(&self) -> CH24R {
        let bits = ((self.bits >> 24) & 0x01) != 0;
        CH24R { bits }
    }
    #[doc = "Bit 23 - Analog I/O switch control of channel CH23"]
    #[inline(always)]
    pub fn ch23(&self) -> CH23R {
        let bits = ((self.bits >> 23) & 0x01) != 0;
        CH23R { bits }
    }
    #[doc = "Bit 22 - Analog I/O switch control of channel CH22"]
    #[inline(always)]
    pub fn ch22(&self) -> CH22R {
        let bits = ((self.bits >> 22) & 0x01) != 0;
        CH22R { bits }
    }
    #[doc = "Bit 21 - Analog switch control"]
    #[inline(always)]
    pub fn ch21gr7_4(&self) -> CH21GR7_4R {
        let bits = ((self.bits >> 21) & 0x01) != 0;
        CH21GR7_4R { bits }
    }
    #[doc = "Bit 20 - Analog switch control"]
    #[inline(always)]
    pub fn ch20gr7_3(&self) -> CH20GR7_3R {
        let bits = ((self.bits >> 20) & 0x01) != 0;
        CH20GR7_3R { bits }
    }
    #[doc = "Bit 19 - Analog switch control"]
    #[inline(always)]
    pub fn ch19gr7_2(&self) -> CH19GR7_2R {
        let bits = ((self.bits >> 19) & 0x01) != 0;
        CH19GR7_2R { bits }
    }
    #[doc = "Bit 18 - Analog switch control"]
    #[inline(always)]
    pub fn ch18gr7_1(&self) -> CH18GR7_1R {
        let bits = ((self.bits >> 18) & 0x01) != 0;
        CH18GR7_1R { bits }
    }
    #[doc = "Bit 16 - Analog switch control"]
    #[inline(always)]
    pub fn ch31gr7_1(&self) -> CH31GR7_1R {
        let bits = ((self.bits >> 16) & 0x01) != 0;
        CH31GR7_1R { bits }
    }
    #[doc = "Bit 15 - Analog switch control"]
    #[inline(always)]
    pub fn ch15gr9_2(&self) -> CH15GR9_2R {
        let bits = ((self.bits >> 15) & 0x01) != 0;
        CH15GR9_2R { bits }
    }
    #[doc = "Bit 14 - Analog switch control"]
    #[inline(always)]
    pub fn ch14gr9_1(&self) -> CH14GR9_1R {
        let bits = ((self.bits >> 14) & 0x01) != 0;
        CH14GR9_1R { bits }
    }
    #[doc = "Bit 13 - Analog switch control"]
    #[inline(always)]
    pub fn ch13gr8_4(&self) -> CH13GR8_4R {
        let bits = ((self.bits >> 13) & 0x01) != 0;
        CH13GR8_4R { bits }
    }
    #[doc = "Bit 12 - Analog switch control"]
    #[inline(always)]
    pub fn ch12gr8_3(&self) -> CH12GR8_3R {
        let bits = ((self.bits >> 12) & 0x01) != 0;
        CH12GR8_3R { bits }
    }
    #[doc = "Bit 11 - Analog switch control"]
    #[inline(always)]
    pub fn ch11gr8_2(&self) -> CH11GR8_2R {
        let bits = ((self.bits >> 11) & 0x01) != 0;
        CH11GR8_2R { bits }
    }
    #[doc = "Bit 10 - Analog switch control"]
    #[inline(always)]
    pub fn ch10gr8_1(&self) -> CH10GR8_1R {
        let bits = ((self.bits >> 10) & 0x01) != 0;
        CH10GR8_1R { bits }
    }
    #[doc = "Bit 9 - Analog switch control"]
    #[inline(always)]
    pub fn ch9gr3_2(&self) -> CH9GR3_2R {
        let bits = ((self.bits >> 9) & 0x01) != 0;
        CH9GR3_2R { bits }
    }
    #[doc = "Bit 8 - Analog switch control"]
    #[inline(always)]
    pub fn ch8gr3_1(&self) -> CH8GR3_1R {
        let bits = ((self.bits >> 8) & 0x01) != 0;
        CH8GR3_1R { bits }
    }
    #[doc = "Bit 7 - Analog switch control"]
    #[inline(always)]
    pub fn ch7gr2_2(&self) -> CH7GR2_2R {
        let bits = ((self.bits >> 7) & 0x01) != 0;
        CH7GR2_2R { bits }
    }
    #[doc = "Bit 6 - Analog switch control"]
    #[inline(always)]
    pub fn ch6gr2_1(&self) -> CH6GR2_1R {
        let bits = ((self.bits >> 6) & 0x01) != 0;
        CH6GR2_1R { bits }
    }
    #[doc = "Bit 5 - Comparator 1 analog switch"]
    #[inline(always)]
    pub fn comp1_sw1(&self) -> COMP1_SW1R {
        let bits = ((self.bits >> 5) & 0x01) != 0;
        COMP1_SW1R { bits }
    }
    #[doc = "Bit 4 - Analog switch control"]
    #[inline(always)]
    pub fn ch31gr11_5(&self) -> CH31GR11_5R {
        let bits = ((self.bits >> 4) & 0x01) != 0;
        CH31GR11_5R { bits }
    }
    #[doc = "Bit 3 - Analog switch control"]
    #[inline(always)]
    pub fn ch3gr1_4(&self) -> CH3GR1_4R {
        let bits = ((self.bits >> 3) & 0x01) != 0;
        CH3GR1_4R { bits }
    }
    #[doc = "Bit 2 - Analog switch control"]
    #[inline(always)]
    pub fn ch2gr1_3(&self) -> CH2GR1_3R {
        let bits = ((self.bits >> 2) & 0x01) != 0;
        CH2GR1_3R { bits }
    }
    #[doc = "Bit 1 - Analog switch control"]
    #[inline(always)]
    pub fn ch1gr1_2(&self) -> CH1GR1_2R {
        let bits = ((self.bits >> 1) & 0x01) != 0;
        CH1GR1_2R { bits }
    }
    #[doc = "Bit 0 - Analog switch control"]
    #[inline(always)]
    pub fn ch0gr1_1(&self) -> CH0GR1_1R {
        let bits = ((self.bits >> 0) & 0x01) != 0;
        CH0GR1_1R { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 31 - Switch control mode"]
    #[inline(always)]
    pub fn scm(&mut self) -> _SCMW {
        _SCMW { w: self }
    }
    #[doc = "Bit 30 - Analog switch control"]
    #[inline(always)]
    pub fn ch30gr11_4(&mut self) -> _CH30GR11_4W {
        _CH30GR11_4W { w: self }
    }
    #[doc = "Bit 29 - Analog switch control"]
    #[inline(always)]
    pub fn ch29gr11_3(&mut self) -> _CH29GR11_3W {
        _CH29GR11_3W { w: self }
    }
    #[doc = "Bit 28 - Analog switch control"]
    #[inline(always)]
    pub fn ch28gr11_2(&mut self) -> _CH28GR11_2W {
        _CH28GR11_2W { w: self }
    }
    #[doc = "Bit 27 - Analog switch control"]
    #[inline(always)]
    pub fn ch27gr11_1(&mut self) -> _CH27GR11_1W {
        _CH27GR11_1W { w: self }
    }
    #[doc = "Bit 26 - ADC analog switch selection for internal node to comparator 1"]
    #[inline(always)]
    pub fn vcomp(&mut self) -> _VCOMPW {
        _VCOMPW { w: self }
    }
    #[doc = "Bit 25 - Analog I/O switch control of channel CH25"]
    #[inline(always)]
    pub fn ch25(&mut self) -> _CH25W {
        _CH25W { w: self }
    }
    #[doc = "Bit 24 - Analog I/O switch control of channel CH24"]
    #[inline(always)]
    pub fn ch24(&mut self) -> _CH24W {
        _CH24W { w: self }
    }
    #[doc = "Bit 23 - Analog I/O switch control of channel CH23"]
    #[inline(always)]
    pub fn ch23(&mut self) -> _CH23W {
        _CH23W { w: self }
    }
    #[doc = "Bit 22 - Analog I/O switch control of channel CH22"]
    #[inline(always)]
    pub fn ch22(&mut self) -> _CH22W {
        _CH22W { w: self }
    }
    #[doc = "Bit 21 - Analog switch control"]
    #[inline(always)]
    pub fn ch21gr7_4(&mut self) -> _CH21GR7_4W {
        _CH21GR7_4W { w: self }
    }
    #[doc = "Bit 20 - Analog switch control"]
    #[inline(always)]
    pub fn ch20gr7_3(&mut self) -> _CH20GR7_3W {
        _CH20GR7_3W { w: self }
    }
    #[doc = "Bit 19 - Analog switch control"]
    #[inline(always)]
    pub fn ch19gr7_2(&mut self) -> _CH19GR7_2W {
        _CH19GR7_2W { w: self }
    }
    #[doc = "Bit 18 - Analog switch control"]
    #[inline(always)]
    pub fn ch18gr7_1(&mut self) -> _CH18GR7_1W {
        _CH18GR7_1W { w: self }
    }
    #[doc = "Bit 16 - Analog switch control"]
    #[inline(always)]
    pub fn ch31gr7_1(&mut self) -> _CH31GR7_1W {
        _CH31GR7_1W { w: self }
    }
    #[doc = "Bit 15 - Analog switch control"]
    #[inline(always)]
    pub fn ch15gr9_2(&mut self) -> _CH15GR9_2W {
        _CH15GR9_2W { w: self }
    }
    #[doc = "Bit 14 - Analog switch control"]
    #[inline(always)]
    pub fn ch14gr9_1(&mut self) -> _CH14GR9_1W {
        _CH14GR9_1W { w: self }
    }
    #[doc = "Bit 13 - Analog switch control"]
    #[inline(always)]
    pub fn ch13gr8_4(&mut self) -> _CH13GR8_4W {
        _CH13GR8_4W { w: self }
    }
    #[doc = "Bit 12 - Analog switch control"]
    #[inline(always)]
    pub fn ch12gr8_3(&mut self) -> _CH12GR8_3W {
        _CH12GR8_3W { w: self }
    }
    #[doc = "Bit 11 - Analog switch control"]
    #[inline(always)]
    pub fn ch11gr8_2(&mut self) -> _CH11GR8_2W {
        _CH11GR8_2W { w: self }
    }
    #[doc = "Bit 10 - Analog switch control"]
    #[inline(always)]
    pub fn ch10gr8_1(&mut self) -> _CH10GR8_1W {
        _CH10GR8_1W { w: self }
    }
    #[doc = "Bit 9 - Analog switch control"]
    #[inline(always)]
    pub fn ch9gr3_2(&mut self) -> _CH9GR3_2W {
        _CH9GR3_2W { w: self }
    }
    #[doc = "Bit 8 - Analog switch control"]
    #[inline(always)]
    pub fn ch8gr3_1(&mut self) -> _CH8GR3_1W {
        _CH8GR3_1W { w: self }
    }
    #[doc = "Bit 7 - Analog switch control"]
    #[inline(always)]
    pub fn ch7gr2_2(&mut self) -> _CH7GR2_2W {
        _CH7GR2_2W { w: self }
    }
    #[doc = "Bit 6 - Analog switch control"]
    #[inline(always)]
    pub fn ch6gr2_1(&mut self) -> _CH6GR2_1W {
        _CH6GR2_1W { w: self }
    }
    #[doc = "Bit 5 - Comparator 1 analog switch"]
    #[inline(always)]
    pub fn comp1_sw1(&mut self) -> _COMP1_SW1W {
        _COMP1_SW1W { w: self }
    }
    #[doc = "Bit 4 - Analog switch control"]
    #[inline(always)]
    pub fn ch31gr11_5(&mut self) -> _CH31GR11_5W {
        _CH31GR11_5W { w: self }
    }
    #[doc = "Bit 3 - Analog switch control"]
    #[inline(always)]
    pub fn ch3gr1_4(&mut self) -> _CH3GR1_4W {
        _CH3GR1_4W { w: self }
    }
    #[doc = "Bit 2 - Analog switch control"]
    #[inline(always)]
    pub fn ch2gr1_3(&mut self) -> _CH2GR1_3W {
        _CH2GR1_3W { w: self }
    }
    #[doc = "Bit 1 - Analog switch control"]
    #[inline(always)]
    pub fn ch1gr1_2(&mut self) -> _CH1GR1_2W {
        _CH1GR1_2W { w: self }
    }
    #[doc = "Bit 0 - Analog switch control"]
    #[inline(always)]
    pub fn ch0gr1_1(&mut self) -> _CH0GR1_1W {
        _CH0GR1_1W { w: self }
    }
}
