#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::ICR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct IC4R {
    bits: bool,
}
impl IC4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _IC4W<'a> {
    w: &'a mut W,
}
impl<'a> _IC4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 21);
        self.w.bits |= ((value as u32) & 0x01) << 21;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct IC3R {
    bits: bool,
}
impl IC3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _IC3W<'a> {
    w: &'a mut W,
}
impl<'a> _IC3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 20);
        self.w.bits |= ((value as u32) & 0x01) << 20;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct IC2R {
    bits: bool,
}
impl IC2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _IC2W<'a> {
    w: &'a mut W,
}
impl<'a> _IC2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 19);
        self.w.bits |= ((value as u32) & 0x01) << 19;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct IC1R {
    bits: bool,
}
impl IC1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _IC1W<'a> {
    w: &'a mut W,
}
impl<'a> _IC1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 18);
        self.w.bits |= ((value as u32) & 0x01) << 18;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct TIMR {
    bits: u8,
}
impl TIMR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _TIMW<'a> {
    w: &'a mut W,
}
impl<'a> _TIMW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x03 << 16);
        self.w.bits |= ((value as u32) & 0x03) << 16;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct IC4IOSR {
    bits: u8,
}
impl IC4IOSR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _IC4IOSW<'a> {
    w: &'a mut W,
}
impl<'a> _IC4IOSW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x0f << 12);
        self.w.bits |= ((value as u32) & 0x0f) << 12;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct IC3IOSR {
    bits: u8,
}
impl IC3IOSR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _IC3IOSW<'a> {
    w: &'a mut W,
}
impl<'a> _IC3IOSW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x0f << 8);
        self.w.bits |= ((value as u32) & 0x0f) << 8;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct IC2IOSR {
    bits: u8,
}
impl IC2IOSR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _IC2IOSW<'a> {
    w: &'a mut W,
}
impl<'a> _IC2IOSW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x0f << 4);
        self.w.bits |= ((value as u32) & 0x0f) << 4;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct IC1IOSR {
    bits: u8,
}
impl IC1IOSR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _IC1IOSW<'a> {
    w: &'a mut W,
}
impl<'a> _IC1IOSW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x0f << 0);
        self.w.bits |= ((value as u32) & 0x0f) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 21 - IC4"]
    #[inline(always)]
    pub fn ic4(&self) -> IC4R {
        let bits = ((self.bits >> 21) & 0x01) != 0;
        IC4R { bits }
    }
    #[doc = "Bit 20 - IC3"]
    #[inline(always)]
    pub fn ic3(&self) -> IC3R {
        let bits = ((self.bits >> 20) & 0x01) != 0;
        IC3R { bits }
    }
    #[doc = "Bit 19 - IC2"]
    #[inline(always)]
    pub fn ic2(&self) -> IC2R {
        let bits = ((self.bits >> 19) & 0x01) != 0;
        IC2R { bits }
    }
    #[doc = "Bit 18 - IC1"]
    #[inline(always)]
    pub fn ic1(&self) -> IC1R {
        let bits = ((self.bits >> 18) & 0x01) != 0;
        IC1R { bits }
    }
    #[doc = "Bits 16:17 - Timer select bits"]
    #[inline(always)]
    pub fn tim(&self) -> TIMR {
        let bits = ((self.bits >> 16) & 0x03) as u8;
        TIMR { bits }
    }
    #[doc = "Bits 12:15 - Input capture 4 select bits"]
    #[inline(always)]
    pub fn ic4ios(&self) -> IC4IOSR {
        let bits = ((self.bits >> 12) & 0x0f) as u8;
        IC4IOSR { bits }
    }
    #[doc = "Bits 8:11 - Input capture 3 select bits"]
    #[inline(always)]
    pub fn ic3ios(&self) -> IC3IOSR {
        let bits = ((self.bits >> 8) & 0x0f) as u8;
        IC3IOSR { bits }
    }
    #[doc = "Bits 4:7 - Input capture 2 select bits"]
    #[inline(always)]
    pub fn ic2ios(&self) -> IC2IOSR {
        let bits = ((self.bits >> 4) & 0x0f) as u8;
        IC2IOSR { bits }
    }
    #[doc = "Bits 0:3 - Input capture 1 select bits"]
    #[inline(always)]
    pub fn ic1ios(&self) -> IC1IOSR {
        let bits = ((self.bits >> 0) & 0x0f) as u8;
        IC1IOSR { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 21 - IC4"]
    #[inline(always)]
    pub fn ic4(&mut self) -> _IC4W {
        _IC4W { w: self }
    }
    #[doc = "Bit 20 - IC3"]
    #[inline(always)]
    pub fn ic3(&mut self) -> _IC3W {
        _IC3W { w: self }
    }
    #[doc = "Bit 19 - IC2"]
    #[inline(always)]
    pub fn ic2(&mut self) -> _IC2W {
        _IC2W { w: self }
    }
    #[doc = "Bit 18 - IC1"]
    #[inline(always)]
    pub fn ic1(&mut self) -> _IC1W {
        _IC1W { w: self }
    }
    #[doc = "Bits 16:17 - Timer select bits"]
    #[inline(always)]
    pub fn tim(&mut self) -> _TIMW {
        _TIMW { w: self }
    }
    #[doc = "Bits 12:15 - Input capture 4 select bits"]
    #[inline(always)]
    pub fn ic4ios(&mut self) -> _IC4IOSW {
        _IC4IOSW { w: self }
    }
    #[doc = "Bits 8:11 - Input capture 3 select bits"]
    #[inline(always)]
    pub fn ic3ios(&mut self) -> _IC3IOSW {
        _IC3IOSW { w: self }
    }
    #[doc = "Bits 4:7 - Input capture 2 select bits"]
    #[inline(always)]
    pub fn ic2ios(&mut self) -> _IC2IOSW {
        _IC2IOSW { w: self }
    }
    #[doc = "Bits 0:3 - Input capture 1 select bits"]
    #[inline(always)]
    pub fn ic1ios(&mut self) -> _IC1IOSW {
        _IC1IOSW { w: self }
    }
}
