#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::OR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct TI1_RMPR {
    bits: u8,
}
impl TI1_RMPR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _TI1_RMPW<'a> {
    w: &'a mut W,
}
impl<'a> _TI1_RMPW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x03 << 0);
        self.w.bits |= ((value as u32) & 0x03) << 0;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct ETR_RMPR {
    bits: bool,
}
impl ETR_RMPR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _ETR_RMPW<'a> {
    w: &'a mut W,
}
impl<'a> _ETR_RMPW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 2);
        self.w.bits |= ((value as u32) & 0x01) << 2;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct TI1_RMP_RIR {
    bits: bool,
}
impl TI1_RMP_RIR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _TI1_RMP_RIW<'a> {
    w: &'a mut W,
}
impl<'a> _TI1_RMP_RIW<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 3);
        self.w.bits |= ((value as u32) & 0x01) << 3;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:1 - TIM11 Input 1 remapping capability"]
    #[inline(always)]
    pub fn ti1_rmp(&self) -> TI1_RMPR {
        let bits = ((self.bits >> 0) & 0x03) as u8;
        TI1_RMPR { bits }
    }
    #[doc = "Bit 2 - Timer11 ETR remap"]
    #[inline(always)]
    pub fn etr_rmp(&self) -> ETR_RMPR {
        let bits = ((self.bits >> 2) & 0x01) != 0;
        ETR_RMPR { bits }
    }
    #[doc = "Bit 3 - Timer11 Input 1 remap for Routing Interface (RI)"]
    #[inline(always)]
    pub fn ti1_rmp_ri(&self) -> TI1_RMP_RIR {
        let bits = ((self.bits >> 3) & 0x01) != 0;
        TI1_RMP_RIR { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:1 - TIM11 Input 1 remapping capability"]
    #[inline(always)]
    pub fn ti1_rmp(&mut self) -> _TI1_RMPW {
        _TI1_RMPW { w: self }
    }
    #[doc = "Bit 2 - Timer11 ETR remap"]
    #[inline(always)]
    pub fn etr_rmp(&mut self) -> _ETR_RMPW {
        _ETR_RMPW { w: self }
    }
    #[doc = "Bit 3 - Timer11 Input 1 remap for Routing Interface (RI)"]
    #[inline(always)]
    pub fn ti1_rmp_ri(&mut self) -> _TI1_RMP_RIW {
        _TI1_RMP_RIW { w: self }
    }
}
