#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - TIM6 control register 1"]
    pub cr1: CR1,
    #[doc = "0x04 - TIM6 control register 2"]
    pub cr2: CR2,
    _reserved2: [u8; 4usize],
    #[doc = "0x0c - TIM6 DMA/Interrupt enable register"]
    pub dier: DIER,
    #[doc = "0x10 - TIM6 status register"]
    pub sr: SR,
    #[doc = "0x14 - TIM6 event generation register"]
    pub egr: EGR,
    _reserved5: [u8; 12usize],
    #[doc = "0x24 - TIM6 counter"]
    pub cnt: CNT,
    #[doc = "0x28 - TIM6 prescaler"]
    pub psc: PSC,
    #[doc = "0x2c - TIM6 auto-reload register"]
    pub arr: ARR,
}
#[doc = "TIM6 control register 1"]
pub struct CR1 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "TIM6 control register 1"]
pub mod cr1;
#[doc = "TIM6 control register 2"]
pub struct CR2 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "TIM6 control register 2"]
pub mod cr2;
#[doc = "TIM6 DMA/Interrupt enable register"]
pub struct DIER {
    register: vcell::VolatileCell<u32>,
}
#[doc = "TIM6 DMA/Interrupt enable register"]
pub mod dier;
#[doc = "TIM6 status register"]
pub struct SR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "TIM6 status register"]
pub mod sr;
#[doc = "TIM6 event generation register"]
pub struct EGR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "TIM6 event generation register"]
pub mod egr;
#[doc = "TIM6 counter"]
pub struct CNT {
    register: vcell::VolatileCell<u32>,
}
#[doc = "TIM6 counter"]
pub mod cnt;
#[doc = "TIM6 prescaler"]
pub struct PSC {
    register: vcell::VolatileCell<u32>,
}
#[doc = "TIM6 prescaler"]
pub mod psc;
#[doc = "TIM6 auto-reload register"]
pub struct ARR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "TIM6 auto-reload register"]
pub mod arr;
