#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::LPOTR {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct AO3_OPT_OFFSET_TRIM_LPR {
    bits: u16,
}
impl AO3_OPT_OFFSET_TRIM_LPR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _AO3_OPT_OFFSET_TRIM_LPW<'a> {
    w: &'a mut W,
}
impl<'a> _AO3_OPT_OFFSET_TRIM_LPW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits &= !(0x03ff << 20);
        self.w.bits |= ((value as u32) & 0x03ff) << 20;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct AO2_OPT_OFFSET_TRIM_LPR {
    bits: u16,
}
impl AO2_OPT_OFFSET_TRIM_LPR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _AO2_OPT_OFFSET_TRIM_LPW<'a> {
    w: &'a mut W,
}
impl<'a> _AO2_OPT_OFFSET_TRIM_LPW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits &= !(0x03ff << 10);
        self.w.bits |= ((value as u32) & 0x03ff) << 10;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct AO1_OPT_OFFSET_TRIM_LPR {
    bits: u16,
}
impl AO1_OPT_OFFSET_TRIM_LPR {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _AO1_OPT_OFFSET_TRIM_LPW<'a> {
    w: &'a mut W,
}
impl<'a> _AO1_OPT_OFFSET_TRIM_LPW<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits &= !(0x03ff << 0);
        self.w.bits |= ((value as u32) & 0x03ff) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 20:29 - OPAMP3, 10-bit offset trim value for low power mode"]
    #[inline(always)]
    pub fn ao3_opt_offset_trim_lp(&self) -> AO3_OPT_OFFSET_TRIM_LPR {
        let bits = ((self.bits >> 20) & 0x03ff) as u16;
        AO3_OPT_OFFSET_TRIM_LPR { bits }
    }
    #[doc = "Bits 10:19 - OPAMP2, 10-bit offset trim value for low power mode"]
    #[inline(always)]
    pub fn ao2_opt_offset_trim_lp(&self) -> AO2_OPT_OFFSET_TRIM_LPR {
        let bits = ((self.bits >> 10) & 0x03ff) as u16;
        AO2_OPT_OFFSET_TRIM_LPR { bits }
    }
    #[doc = "Bits 0:9 - OPAMP1, 10-bit offset trim value for low power mode"]
    #[inline(always)]
    pub fn ao1_opt_offset_trim_lp(&self) -> AO1_OPT_OFFSET_TRIM_LPR {
        let bits = ((self.bits >> 0) & 0x03ff) as u16;
        AO1_OPT_OFFSET_TRIM_LPR { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 20:29 - OPAMP3, 10-bit offset trim value for low power mode"]
    #[inline(always)]
    pub fn ao3_opt_offset_trim_lp(&mut self) -> _AO3_OPT_OFFSET_TRIM_LPW {
        _AO3_OPT_OFFSET_TRIM_LPW { w: self }
    }
    #[doc = "Bits 10:19 - OPAMP2, 10-bit offset trim value for low power mode"]
    #[inline(always)]
    pub fn ao2_opt_offset_trim_lp(&mut self) -> _AO2_OPT_OFFSET_TRIM_LPW {
        _AO2_OPT_OFFSET_TRIM_LPW { w: self }
    }
    #[doc = "Bits 0:9 - OPAMP1, 10-bit offset trim value for low power mode"]
    #[inline(always)]
    pub fn ao1_opt_offset_trim_lp(&mut self) -> _AO1_OPT_OFFSET_TRIM_LPW {
        _AO1_OPT_OFFSET_TRIM_LPW { w: self }
    }
}
