#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    _reserved0: [u8; 4usize],
    #[doc = "0x04 - RI input capture register"]
    pub icr: ICR,
    #[doc = "0x08 - RI analog switches control register 1"]
    pub ascr1: ASCR1,
    #[doc = "0x0c - RI analog switches control register 2"]
    pub ascr2: ASCR2,
    #[doc = "0x10 - RI hysteresis control register 1"]
    pub hyscr1: HYSCR1,
    #[doc = "0x14 - RI hysteresis control register 2"]
    pub hyscr2: HYSCR2,
    #[doc = "0x18 - RI hysteresis control register 3"]
    pub hyscr3: HYSCR3,
    #[doc = "0x1c - Hysteresis control register"]
    pub hyscr4: HYSCR4,
}
#[doc = "RI input capture register"]
pub struct ICR {
    register: vcell::VolatileCell<u32>,
}
#[doc = "RI input capture register"]
pub mod icr;
#[doc = "RI analog switches control register 1"]
pub struct ASCR1 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "RI analog switches control register 1"]
pub mod ascr1;
#[doc = "RI analog switches control register 2"]
pub struct ASCR2 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "RI analog switches control register 2"]
pub mod ascr2;
#[doc = "RI hysteresis control register 1"]
pub struct HYSCR1 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "RI hysteresis control register 1"]
pub mod hyscr1;
#[doc = "RI hysteresis control register 2"]
pub struct HYSCR2 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "RI hysteresis control register 2"]
pub mod hyscr2;
#[doc = "RI hysteresis control register 3"]
pub struct HYSCR3 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "RI hysteresis control register 3"]
pub mod hyscr3;
#[doc = "Hysteresis control register"]
pub struct HYSCR4 {
    register: vcell::VolatileCell<u32>,
}
#[doc = "Hysteresis control register"]
pub mod hyscr4;
