#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::ASCR2 {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct GR5_4R {
    bits: bool,
}
impl GR5_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR5_4W<'a> {
    w: &'a mut W,
}
impl<'a> _GR5_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 29);
        self.w.bits |= ((value as u32) & 0x01) << 29;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR6_4R {
    bits: bool,
}
impl GR6_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR6_4W<'a> {
    w: &'a mut W,
}
impl<'a> _GR6_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 28);
        self.w.bits |= ((value as u32) & 0x01) << 28;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR6_3R {
    bits: bool,
}
impl GR6_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR6_3W<'a> {
    w: &'a mut W,
}
impl<'a> _GR6_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 27);
        self.w.bits |= ((value as u32) & 0x01) << 27;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR7_7R {
    bits: bool,
}
impl GR7_7R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR7_7W<'a> {
    w: &'a mut W,
}
impl<'a> _GR7_7W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 26);
        self.w.bits |= ((value as u32) & 0x01) << 26;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR7_6R {
    bits: bool,
}
impl GR7_6R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR7_6W<'a> {
    w: &'a mut W,
}
impl<'a> _GR7_6W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 25);
        self.w.bits |= ((value as u32) & 0x01) << 25;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR7_5R {
    bits: bool,
}
impl GR7_5R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR7_5W<'a> {
    w: &'a mut W,
}
impl<'a> _GR7_5W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 24);
        self.w.bits |= ((value as u32) & 0x01) << 24;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR2_5R {
    bits: bool,
}
impl GR2_5R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR2_5W<'a> {
    w: &'a mut W,
}
impl<'a> _GR2_5W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 23);
        self.w.bits |= ((value as u32) & 0x01) << 23;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR2_4R {
    bits: bool,
}
impl GR2_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR2_4W<'a> {
    w: &'a mut W,
}
impl<'a> _GR2_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 22);
        self.w.bits |= ((value as u32) & 0x01) << 22;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR2_3R {
    bits: bool,
}
impl GR2_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR2_3W<'a> {
    w: &'a mut W,
}
impl<'a> _GR2_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 21);
        self.w.bits |= ((value as u32) & 0x01) << 21;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR9_4R {
    bits: bool,
}
impl GR9_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR9_4W<'a> {
    w: &'a mut W,
}
impl<'a> _GR9_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 20);
        self.w.bits |= ((value as u32) & 0x01) << 20;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR9_3R {
    bits: bool,
}
impl GR9_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR9_3W<'a> {
    w: &'a mut W,
}
impl<'a> _GR9_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 19);
        self.w.bits |= ((value as u32) & 0x01) << 19;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR3_5R {
    bits: bool,
}
impl GR3_5R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR3_5W<'a> {
    w: &'a mut W,
}
impl<'a> _GR3_5W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 18);
        self.w.bits |= ((value as u32) & 0x01) << 18;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR3_4R {
    bits: bool,
}
impl GR3_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR3_4W<'a> {
    w: &'a mut W,
}
impl<'a> _GR3_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 17);
        self.w.bits |= ((value as u32) & 0x01) << 17;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR3_3R {
    bits: bool,
}
impl GR3_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR3_3W<'a> {
    w: &'a mut W,
}
impl<'a> _GR3_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 16);
        self.w.bits |= ((value as u32) & 0x01) << 16;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR4_3R {
    bits: bool,
}
impl GR4_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR4_3W<'a> {
    w: &'a mut W,
}
impl<'a> _GR4_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 11);
        self.w.bits |= ((value as u32) & 0x01) << 11;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR4_2R {
    bits: bool,
}
impl GR4_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR4_2W<'a> {
    w: &'a mut W,
}
impl<'a> _GR4_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 10);
        self.w.bits |= ((value as u32) & 0x01) << 10;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR4_1R {
    bits: bool,
}
impl GR4_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR4_1W<'a> {
    w: &'a mut W,
}
impl<'a> _GR4_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 9);
        self.w.bits |= ((value as u32) & 0x01) << 9;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR5_3R {
    bits: bool,
}
impl GR5_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR5_3W<'a> {
    w: &'a mut W,
}
impl<'a> _GR5_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 8);
        self.w.bits |= ((value as u32) & 0x01) << 8;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR5_2R {
    bits: bool,
}
impl GR5_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR5_2W<'a> {
    w: &'a mut W,
}
impl<'a> _GR5_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 7);
        self.w.bits |= ((value as u32) & 0x01) << 7;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR5_1R {
    bits: bool,
}
impl GR5_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR5_1W<'a> {
    w: &'a mut W,
}
impl<'a> _GR5_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 6);
        self.w.bits |= ((value as u32) & 0x01) << 6;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR6_2R {
    bits: bool,
}
impl GR6_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR6_2W<'a> {
    w: &'a mut W,
}
impl<'a> _GR6_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 5);
        self.w.bits |= ((value as u32) & 0x01) << 5;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR6_1R {
    bits: bool,
}
impl GR6_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR6_1W<'a> {
    w: &'a mut W,
}
impl<'a> _GR6_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 4);
        self.w.bits |= ((value as u32) & 0x01) << 4;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR10_4R {
    bits: bool,
}
impl GR10_4R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR10_4W<'a> {
    w: &'a mut W,
}
impl<'a> _GR10_4W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 3);
        self.w.bits |= ((value as u32) & 0x01) << 3;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR10_3R {
    bits: bool,
}
impl GR10_3R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR10_3W<'a> {
    w: &'a mut W,
}
impl<'a> _GR10_3W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 2);
        self.w.bits |= ((value as u32) & 0x01) << 2;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR10_2R {
    bits: bool,
}
impl GR10_2R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR10_2W<'a> {
    w: &'a mut W,
}
impl<'a> _GR10_2W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 1);
        self.w.bits |= ((value as u32) & 0x01) << 1;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct GR10_1R {
    bits: bool,
}
impl GR10_1R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bit(&self) -> bool {
        self.bits
    }
    #[doc = r"Returns `true` if the bit is clear (0)"]
    #[inline(always)]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r"Returns `true` if the bit is set (1)"]
    #[inline(always)]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
}
#[doc = r"Proxy"]
pub struct _GR10_1W<'a> {
    w: &'a mut W,
}
impl<'a> _GR10_1W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits &= !(0x01 << 0);
        self.w.bits |= ((value as u32) & 0x01) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 29 - GR5_4 analog switch control"]
    #[inline(always)]
    pub fn gr5_4(&self) -> GR5_4R {
        let bits = ((self.bits >> 29) & 0x01) != 0;
        GR5_4R { bits }
    }
    #[doc = "Bit 28 - GR6_4 analog switch control"]
    #[inline(always)]
    pub fn gr6_4(&self) -> GR6_4R {
        let bits = ((self.bits >> 28) & 0x01) != 0;
        GR6_4R { bits }
    }
    #[doc = "Bit 27 - GR6_3 analog switch control"]
    #[inline(always)]
    pub fn gr6_3(&self) -> GR6_3R {
        let bits = ((self.bits >> 27) & 0x01) != 0;
        GR6_3R { bits }
    }
    #[doc = "Bit 26 - GR7_7 analog switch control"]
    #[inline(always)]
    pub fn gr7_7(&self) -> GR7_7R {
        let bits = ((self.bits >> 26) & 0x01) != 0;
        GR7_7R { bits }
    }
    #[doc = "Bit 25 - GR7_6 analog switch control"]
    #[inline(always)]
    pub fn gr7_6(&self) -> GR7_6R {
        let bits = ((self.bits >> 25) & 0x01) != 0;
        GR7_6R { bits }
    }
    #[doc = "Bit 24 - GR7_5 analog switch control"]
    #[inline(always)]
    pub fn gr7_5(&self) -> GR7_5R {
        let bits = ((self.bits >> 24) & 0x01) != 0;
        GR7_5R { bits }
    }
    #[doc = "Bit 23 - GR2_5 analog switch control"]
    #[inline(always)]
    pub fn gr2_5(&self) -> GR2_5R {
        let bits = ((self.bits >> 23) & 0x01) != 0;
        GR2_5R { bits }
    }
    #[doc = "Bit 22 - GR2_4 analog switch control"]
    #[inline(always)]
    pub fn gr2_4(&self) -> GR2_4R {
        let bits = ((self.bits >> 22) & 0x01) != 0;
        GR2_4R { bits }
    }
    #[doc = "Bit 21 - GR2_3 analog switch control"]
    #[inline(always)]
    pub fn gr2_3(&self) -> GR2_3R {
        let bits = ((self.bits >> 21) & 0x01) != 0;
        GR2_3R { bits }
    }
    #[doc = "Bit 20 - GR9_4 analog switch control"]
    #[inline(always)]
    pub fn gr9_4(&self) -> GR9_4R {
        let bits = ((self.bits >> 20) & 0x01) != 0;
        GR9_4R { bits }
    }
    #[doc = "Bit 19 - GR9_3 analog switch control"]
    #[inline(always)]
    pub fn gr9_3(&self) -> GR9_3R {
        let bits = ((self.bits >> 19) & 0x01) != 0;
        GR9_3R { bits }
    }
    #[doc = "Bit 18 - GR3_5 analog switch control"]
    #[inline(always)]
    pub fn gr3_5(&self) -> GR3_5R {
        let bits = ((self.bits >> 18) & 0x01) != 0;
        GR3_5R { bits }
    }
    #[doc = "Bit 17 - GR3_4 analog switch control"]
    #[inline(always)]
    pub fn gr3_4(&self) -> GR3_4R {
        let bits = ((self.bits >> 17) & 0x01) != 0;
        GR3_4R { bits }
    }
    #[doc = "Bit 16 - GR3_3 analog switch control"]
    #[inline(always)]
    pub fn gr3_3(&self) -> GR3_3R {
        let bits = ((self.bits >> 16) & 0x01) != 0;
        GR3_3R { bits }
    }
    #[doc = "Bit 11 - GR4_3 analog switch control"]
    #[inline(always)]
    pub fn gr4_3(&self) -> GR4_3R {
        let bits = ((self.bits >> 11) & 0x01) != 0;
        GR4_3R { bits }
    }
    #[doc = "Bit 10 - GR4_2 analog switch control"]
    #[inline(always)]
    pub fn gr4_2(&self) -> GR4_2R {
        let bits = ((self.bits >> 10) & 0x01) != 0;
        GR4_2R { bits }
    }
    #[doc = "Bit 9 - GR4_1 analog switch control"]
    #[inline(always)]
    pub fn gr4_1(&self) -> GR4_1R {
        let bits = ((self.bits >> 9) & 0x01) != 0;
        GR4_1R { bits }
    }
    #[doc = "Bit 8 - GR5_3 analog switch control"]
    #[inline(always)]
    pub fn gr5_3(&self) -> GR5_3R {
        let bits = ((self.bits >> 8) & 0x01) != 0;
        GR5_3R { bits }
    }
    #[doc = "Bit 7 - GR5_2 analog switch control"]
    #[inline(always)]
    pub fn gr5_2(&self) -> GR5_2R {
        let bits = ((self.bits >> 7) & 0x01) != 0;
        GR5_2R { bits }
    }
    #[doc = "Bit 6 - GR5_1 analog switch control"]
    #[inline(always)]
    pub fn gr5_1(&self) -> GR5_1R {
        let bits = ((self.bits >> 6) & 0x01) != 0;
        GR5_1R { bits }
    }
    #[doc = "Bit 5 - GR6_2 analog switch control"]
    #[inline(always)]
    pub fn gr6_2(&self) -> GR6_2R {
        let bits = ((self.bits >> 5) & 0x01) != 0;
        GR6_2R { bits }
    }
    #[doc = "Bit 4 - GR6_1 analog switch control"]
    #[inline(always)]
    pub fn gr6_1(&self) -> GR6_1R {
        let bits = ((self.bits >> 4) & 0x01) != 0;
        GR6_1R { bits }
    }
    #[doc = "Bit 3 - GR10_4 analog switch control"]
    #[inline(always)]
    pub fn gr10_4(&self) -> GR10_4R {
        let bits = ((self.bits >> 3) & 0x01) != 0;
        GR10_4R { bits }
    }
    #[doc = "Bit 2 - GR10_3 analog switch control"]
    #[inline(always)]
    pub fn gr10_3(&self) -> GR10_3R {
        let bits = ((self.bits >> 2) & 0x01) != 0;
        GR10_3R { bits }
    }
    #[doc = "Bit 1 - GR10_2 analog switch control"]
    #[inline(always)]
    pub fn gr10_2(&self) -> GR10_2R {
        let bits = ((self.bits >> 1) & 0x01) != 0;
        GR10_2R { bits }
    }
    #[doc = "Bit 0 - GR10_1 analog switch control"]
    #[inline(always)]
    pub fn gr10_1(&self) -> GR10_1R {
        let bits = ((self.bits >> 0) & 0x01) != 0;
        GR10_1R { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 29 - GR5_4 analog switch control"]
    #[inline(always)]
    pub fn gr5_4(&mut self) -> _GR5_4W {
        _GR5_4W { w: self }
    }
    #[doc = "Bit 28 - GR6_4 analog switch control"]
    #[inline(always)]
    pub fn gr6_4(&mut self) -> _GR6_4W {
        _GR6_4W { w: self }
    }
    #[doc = "Bit 27 - GR6_3 analog switch control"]
    #[inline(always)]
    pub fn gr6_3(&mut self) -> _GR6_3W {
        _GR6_3W { w: self }
    }
    #[doc = "Bit 26 - GR7_7 analog switch control"]
    #[inline(always)]
    pub fn gr7_7(&mut self) -> _GR7_7W {
        _GR7_7W { w: self }
    }
    #[doc = "Bit 25 - GR7_6 analog switch control"]
    #[inline(always)]
    pub fn gr7_6(&mut self) -> _GR7_6W {
        _GR7_6W { w: self }
    }
    #[doc = "Bit 24 - GR7_5 analog switch control"]
    #[inline(always)]
    pub fn gr7_5(&mut self) -> _GR7_5W {
        _GR7_5W { w: self }
    }
    #[doc = "Bit 23 - GR2_5 analog switch control"]
    #[inline(always)]
    pub fn gr2_5(&mut self) -> _GR2_5W {
        _GR2_5W { w: self }
    }
    #[doc = "Bit 22 - GR2_4 analog switch control"]
    #[inline(always)]
    pub fn gr2_4(&mut self) -> _GR2_4W {
        _GR2_4W { w: self }
    }
    #[doc = "Bit 21 - GR2_3 analog switch control"]
    #[inline(always)]
    pub fn gr2_3(&mut self) -> _GR2_3W {
        _GR2_3W { w: self }
    }
    #[doc = "Bit 20 - GR9_4 analog switch control"]
    #[inline(always)]
    pub fn gr9_4(&mut self) -> _GR9_4W {
        _GR9_4W { w: self }
    }
    #[doc = "Bit 19 - GR9_3 analog switch control"]
    #[inline(always)]
    pub fn gr9_3(&mut self) -> _GR9_3W {
        _GR9_3W { w: self }
    }
    #[doc = "Bit 18 - GR3_5 analog switch control"]
    #[inline(always)]
    pub fn gr3_5(&mut self) -> _GR3_5W {
        _GR3_5W { w: self }
    }
    #[doc = "Bit 17 - GR3_4 analog switch control"]
    #[inline(always)]
    pub fn gr3_4(&mut self) -> _GR3_4W {
        _GR3_4W { w: self }
    }
    #[doc = "Bit 16 - GR3_3 analog switch control"]
    #[inline(always)]
    pub fn gr3_3(&mut self) -> _GR3_3W {
        _GR3_3W { w: self }
    }
    #[doc = "Bit 11 - GR4_3 analog switch control"]
    #[inline(always)]
    pub fn gr4_3(&mut self) -> _GR4_3W {
        _GR4_3W { w: self }
    }
    #[doc = "Bit 10 - GR4_2 analog switch control"]
    #[inline(always)]
    pub fn gr4_2(&mut self) -> _GR4_2W {
        _GR4_2W { w: self }
    }
    #[doc = "Bit 9 - GR4_1 analog switch control"]
    #[inline(always)]
    pub fn gr4_1(&mut self) -> _GR4_1W {
        _GR4_1W { w: self }
    }
    #[doc = "Bit 8 - GR5_3 analog switch control"]
    #[inline(always)]
    pub fn gr5_3(&mut self) -> _GR5_3W {
        _GR5_3W { w: self }
    }
    #[doc = "Bit 7 - GR5_2 analog switch control"]
    #[inline(always)]
    pub fn gr5_2(&mut self) -> _GR5_2W {
        _GR5_2W { w: self }
    }
    #[doc = "Bit 6 - GR5_1 analog switch control"]
    #[inline(always)]
    pub fn gr5_1(&mut self) -> _GR5_1W {
        _GR5_1W { w: self }
    }
    #[doc = "Bit 5 - GR6_2 analog switch control"]
    #[inline(always)]
    pub fn gr6_2(&mut self) -> _GR6_2W {
        _GR6_2W { w: self }
    }
    #[doc = "Bit 4 - GR6_1 analog switch control"]
    #[inline(always)]
    pub fn gr6_1(&mut self) -> _GR6_1W {
        _GR6_1W { w: self }
    }
    #[doc = "Bit 3 - GR10_4 analog switch control"]
    #[inline(always)]
    pub fn gr10_4(&mut self) -> _GR10_4W {
        _GR10_4W { w: self }
    }
    #[doc = "Bit 2 - GR10_3 analog switch control"]
    #[inline(always)]
    pub fn gr10_3(&mut self) -> _GR10_3W {
        _GR10_3W { w: self }
    }
    #[doc = "Bit 1 - GR10_2 analog switch control"]
    #[inline(always)]
    pub fn gr10_2(&mut self) -> _GR10_2W {
        _GR10_2W { w: self }
    }
    #[doc = "Bit 0 - GR10_1 analog switch control"]
    #[inline(always)]
    pub fn gr10_1(&mut self) -> _GR10_1W {
        _GR10_1W { w: self }
    }
}
