#[doc = r"Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r"Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::EXTICR4 {
    #[doc = r"Modifies the contents of the register"]
    #[inline(always)]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        self.register.set(f(&R { bits }, &mut W { bits }).bits);
    }
    #[doc = r"Reads the contents of the register"]
    #[inline(always)]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r"Writes to the register"]
    #[inline(always)]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        self.register.set(
            f(&mut W {
                bits: Self::reset_value(),
            })
            .bits,
        );
    }
    #[doc = r"Reset value of the register"]
    #[inline(always)]
    pub const fn reset_value() -> u32 {
        0
    }
    #[doc = r"Writes the reset value to the register"]
    #[inline(always)]
    pub fn reset(&self) {
        self.register.set(Self::reset_value())
    }
}
#[doc = r"Value of the field"]
pub struct EXTI15R {
    bits: u8,
}
impl EXTI15R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _EXTI15W<'a> {
    w: &'a mut W,
}
impl<'a> _EXTI15W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x0f << 12);
        self.w.bits |= ((value as u32) & 0x0f) << 12;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct EXTI14R {
    bits: u8,
}
impl EXTI14R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _EXTI14W<'a> {
    w: &'a mut W,
}
impl<'a> _EXTI14W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x0f << 8);
        self.w.bits |= ((value as u32) & 0x0f) << 8;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct EXTI13R {
    bits: u8,
}
impl EXTI13R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _EXTI13W<'a> {
    w: &'a mut W,
}
impl<'a> _EXTI13W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x0f << 4);
        self.w.bits |= ((value as u32) & 0x0f) << 4;
        self.w
    }
}
#[doc = r"Value of the field"]
pub struct EXTI12R {
    bits: u8,
}
impl EXTI12R {
    #[doc = r"Value of the field as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r"Proxy"]
pub struct _EXTI12W<'a> {
    w: &'a mut W,
}
impl<'a> _EXTI12W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits &= !(0x0f << 0);
        self.w.bits |= ((value as u32) & 0x0f) << 0;
        self.w
    }
}
impl R {
    #[doc = r"Value of the register as raw bits"]
    #[inline(always)]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 12:15 - EXTI x configuration (x = 12 to 15)"]
    #[inline(always)]
    pub fn exti15(&self) -> EXTI15R {
        let bits = ((self.bits >> 12) & 0x0f) as u8;
        EXTI15R { bits }
    }
    #[doc = "Bits 8:11 - EXTI14"]
    #[inline(always)]
    pub fn exti14(&self) -> EXTI14R {
        let bits = ((self.bits >> 8) & 0x0f) as u8;
        EXTI14R { bits }
    }
    #[doc = "Bits 4:7 - EXTI13"]
    #[inline(always)]
    pub fn exti13(&self) -> EXTI13R {
        let bits = ((self.bits >> 4) & 0x0f) as u8;
        EXTI13R { bits }
    }
    #[doc = "Bits 0:3 - EXTI12"]
    #[inline(always)]
    pub fn exti12(&self) -> EXTI12R {
        let bits = ((self.bits >> 0) & 0x0f) as u8;
        EXTI12R { bits }
    }
}
impl W {
    #[doc = r"Writes raw bits to the register"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 12:15 - EXTI x configuration (x = 12 to 15)"]
    #[inline(always)]
    pub fn exti15(&mut self) -> _EXTI15W {
        _EXTI15W { w: self }
    }
    #[doc = "Bits 8:11 - EXTI14"]
    #[inline(always)]
    pub fn exti14(&mut self) -> _EXTI14W {
        _EXTI14W { w: self }
    }
    #[doc = "Bits 4:7 - EXTI13"]
    #[inline(always)]
    pub fn exti13(&mut self) -> _EXTI13W {
        _EXTI13W { w: self }
    }
    #[doc = "Bits 0:3 - EXTI12"]
    #[inline(always)]
    pub fn exti12(&mut self) -> _EXTI12W {
        _EXTI12W { w: self }
    }
}
